public class CoordinateMapper {
  // x Scale
  double userStart, userEnd;
  double screenStart, screenEnd;
  double scale;

  CoordinateMapper(int userStart, int userEnd, int screenStart, int screenEnd)
  {
    this.userStart = (double)userStart;
    this.userEnd = (double)userEnd;
    this.screenStart = (double)screenStart;
    this.screenEnd = (double)screenEnd;

    this.scale = (this.screenEnd - this.screenStart) / 
                 (this.userEnd - this.userStart);
  }

  int getScale()
  {
    return (int)scale;
  }

  int user2Screen(int user)
  {
    int screen;

    screen = (int)(screenStart + ((double)user - userStart)*scale);

    // clipping
    if((double)screen < screenStart) return (int)screenStart;
    else if((double)screen > screenEnd) return (int)screenEnd;
    else return(screen);
  }

  int screen2User(int screen)
  {
    int user;

    user = (int)(userStart + ((double)screen - screenStart)/scale);

    // clipping
    if((double)user < userStart) return (int)userStart;
    else if((double)user > userEnd) return (int)userEnd;
    else return(user);
  }
}
