import java.awt.*;
import java.net.*;
import java.util.*;

class TimeBar {
  // implementation
  int startPos;
  int endPos;
  Color color;
}

class PlainTimeBar extends TimeBar {
}

public class Task {
  // implementation
  String caption;
  String responsavel;
  String status;
  String estimateStartLabel;
  String estimateEndLabel;
  String currentStartLabel;
  String currentEndLabel;
  Link caption_link;
  PlainTimeBar estimate;
  PlainTimeBar current;
  Link current_link;
  
	final int DAYSECONDS = 86400; //3600 * 24
	
  // valores para status -- indicado pelo usuario
  final String NAO_INICIADO = "marca";
  final String EM_ALERTA    = "alerta";
  final String ATRASADO     = "atrasado";
  final String CONCLUIDO    = "concluido";
  final String EM_ANDAMENTO = "em andamento";
  final String VAZIO        = "nada";
  final int datelabelsize = 11;

  Task()
  {
  	responsavel = null;
    caption = null;
    caption_link = new Link();
    status = null;
    estimateStartLabel = null;
    estimateEndLabel = null;
    currentStartLabel = null;
    currentEndLabel = null;
    estimate = new PlainTimeBar();
    current = new PlainTimeBar();
    current_link = new Link();
  }


 int days2Seconds(int days) {
	 return(days * DAYSECONDS);
 }


  // Caption ......................................................
  
  public void setCaption(String caption)
  {
    this.caption = caption;
  }

  public void setResponsavel(String responsavel)
  {
    this.responsavel = responsavel;
  }
  
  public String getResponsavel()
  {
    return responsavel;
  }

  public String getCaption()
  {
    return caption;
  }

  public void setCaptionURL(String url)
  {
    caption_link.setURL(url);
  }

  public String getCaptionURL()
  {
    return caption_link.getURL();
  }

  public Link getCaptionLink()
  {
    return caption_link;
  }

  public void setCaptionFrame(String target)
  {
    caption_link.setFrame(target);
  }

  public String getCaptionFrame()
  {
    return caption_link.getFrame();
  }

  // Current Date ...................................................

  public void setCurrentURL(String url)
  {
    current_link.setURL(url);
  }

  public String getCurrentURL()
  {
    return current_link.getURL();
  }

  public Link getCurrentLink()
  {
    return current_link;
  }

  public void setCurrentFrame(String target)
  {
    current_link.setFrame(target);
  }

  public String getCurrentFrame()
  {
    return current_link.getFrame();
  }

  public void setStatus(String status)
  {
    this.status = status;
  }

  public void setEstimatedStart(int start)
  {
  	this.estimate.startPos = start;
  	
  } 

  public void setEstimatedEnd(int end)
  {
    this.estimate.endPos = end;
  } 

  public void setCurrentStart(int start)
  {
    this.current.startPos = start;
  } 

  public void setCurrentEnd(int end)
  {
    this.current.endPos = end;
  }

  public int getCurrentEnd()
  {
    return(this.current.endPos);
  }

//Date labels:
  public void setEstimatedStartLabel(String start)
  {
  	this.estimateStartLabel = start;
  
  } 
  
  public String getEstimatedStartLabel()
  {
    
    return(this.estimateStartLabel);
  }

  public void setEstimatedEndLabel(String end)
  {
    this.estimateEndLabel = end;
  } 
  
  public String getEstimatedEndLabel()
  {
    return(this.estimateEndLabel);
  } 

  public void setCurrentStartLabel(String start)
  {
    this.currentStartLabel = start;
  } 

  public String getCurrentStartLabel()
  {
    return(this.currentStartLabel);
  } 

  public void setCurrentEndLabel(String end)
  {
    this.currentEndLabel = end;
  }

  public String getCurrentEndLabel()
  {
    return(this.currentEndLabel);
  }

  public void drawBars(Graphics g, int y, int height, CoordinateMapper mapper,
                       HotSpot hotspots)
  {
    Color barColor;
    int xpos, ypos;
    int upperMargin, barWidth, barHeight, deltaleft;
    Point p, pdatainicurrent, pdatafimcurrent,pdatainic, pdatafim;
    Bar bar;
    Diamond diamond;
    String datelabel;
    Abc datainic, datafim, datainicurrent, datafimcurrent;
    Long x = new Long(days2Seconds(estimate.startPos));
    // no mapper
    if(mapper==null)
      return;

    upperMargin = 14;
    barHeight = 10;
    deltaleft = 32;

    // estimate
    xpos = mapper.user2Screen(estimate.startPos);
    ypos = y + upperMargin; 
    p = new Point(xpos, ypos);
    barWidth = mapper.user2Screen(estimate.endPos) - mapper.user2Screen(estimate.startPos);
    barColor = CustomColor.x666666;
    bar = new Bar(p, barWidth, barHeight, barColor); 
    bar.draw(g);
    //Escreve as datas
    //datelabel = SecsToDate(days2Seconds(estimate.startPos));
    datelabel = getEstimatedStartLabel();
    datainic = new Abc(datelabel,datelabelsize);
    pdatainic = new Point(xpos - deltaleft,ypos + barHeight);
    datainic.setPosition(pdatainic);
    datainic.setColor(CustomColor.x666666);
    datainic.setAlign(-3,-1);
    datainic.draw(g);
    //g.drawString(datelabel, (xpos - deltaleft), ypos + barHeight);
    //datelabel = SecsToDate(days2Seconds(estimate.endPos));
    datelabel = getEstimatedEndLabel();
    datafim = new Abc(datelabel,datelabelsize);
    pdatafim = new Point(xpos + barWidth,ypos + barHeight);
    datafim.setPosition(pdatafim);
    datafim.setColor(CustomColor.x666666);
    datafim.setAlign(-1,-1);
    datafim.draw(g);
    //g.drawString(datelabel, (xpos + barWidth), ypos + barHeight);
    
    if(hotspots != null) {
        hotspots.add(xpos,ypos,barWidth,barHeight, this.getCurrentLink());
    }
    

    // current
    // Data de hoje < Data de startPos
    if(status.equalsIgnoreCase(VAZIO))
      return;

    if(status.equalsIgnoreCase(NAO_INICIADO)) {
      ypos = y + height - upperMargin - barHeight;
      p = new Point(xpos, ypos);
      diamond = new Diamond(p);
      diamond.setAlign(0); // center
      diamond.draw(g);

      // add hotspot
      if(hotspots != null) {
        hotspots.add(diamond.x(),diamond.y(),diamond.width(),diamond.height(), 
                     this.getCurrentLink());
      }
    }
    else {
      xpos = mapper.user2Screen(current.startPos);
      ypos = y + height - upperMargin - barHeight;
      p = new Point(xpos, ypos);
      barWidth = mapper.user2Screen(current.endPos) - mapper.user2Screen(current.startPos);
      barColor = status2Color();
      bar = new Bar(p, barWidth, barHeight, barColor); 
      bar.draw(g);
      //Escreve as datas
      //datelabel = SecsToDate(days2Seconds(current.startPos));
      datelabel = getCurrentStartLabel();
      datainicurrent = new Abc(datelabel,datelabelsize);
      pdatainicurrent = new Point(xpos - deltaleft,ypos + barHeight);
      datainicurrent.setPosition(pdatainicurrent);
      datainicurrent.setColor(CustomColor.x666666);
      datainicurrent.setAlign(-1,-1);
      datainicurrent.draw(g);
      //g.drawString(datelabel, (xpos - deltaleft), ypos + barHeight);
      //datelabel = SecsToDate(days2Seconds(current.endPos));
      datelabel = getCurrentEndLabel();
      datafimcurrent = new Abc(datelabel,datelabelsize);
      pdatafimcurrent = new Point(xpos + barWidth,ypos + barHeight);
      datafimcurrent.setPosition(pdatafimcurrent);
      datafimcurrent.setColor(CustomColor.x666666);
      datafimcurrent.setAlign(-1,-1);
      datafimcurrent.draw(g);
      //g.drawString(datelabel, (xpos + barWidth), ypos + barHeight);
      if(hotspots != null) {
        hotspots.add(xpos,ypos,barWidth,barHeight, this.getCurrentLink());
      }
    }
  }

   String SecsToDate(long num) {
     Date d = new Date(num * 1000);
     Integer mon = new Integer(1 + d.getMonth());
     Integer day = new Integer(d.getDate());
     String sday, smon;
     if (d.getDate() < 10) {
     	 sday = '0'+ day.toString();
     }
     else{
       sday = day.toString();
     }
     //A contagem do mes comeca a partir de 0
     if  (d.getMonth() < 9) {
     	  smon = '0' + mon.toString();
     }
     else {
     	  smon = mon.toString();
     }
     
     return (sday + '/'+ smon);
   }

  private Color status2Color()
  {
    if(status.equalsIgnoreCase(ATRASADO))
      return CustomColor.xFF3300;
    else if(status.equalsIgnoreCase(EM_ALERTA))
      return CustomColor.xFFCC00;
    else if(status.equalsIgnoreCase(CONCLUIDO))
      return CustomColor.x009900;
    else if(status.equalsIgnoreCase(EM_ANDAMENTO))
      return CustomColor.x99CCFF;
    else // default
      return CustomColor.x666666;
  }

 
}

