import java.awt.*;
import java.net.*;
import java.util.Vector;

abstract class HRegion {
  Link link;

  // isIn -- abstract
  abstract boolean isIn(int x, int y);

  Link link()
  {
    return(link);
  }
}

class HRectangle extends HRegion {
  Rectangle r;

  // Constructor
  HRectangle(int x0,int y0, int width,int height, Link link)
  {
    this.link = link;
    r = new Rectangle(x0, y0, width, height);
  }
  
  boolean isIn(int x, int y)
  {
    return(r.inside(x,y));
  }
}


class HotSpot {
  Vector spots;

  // constructor
  HotSpot()
  {
    spots = new Vector(); 
  }  

  // for a rectangular region
  void add(int x, int y, int width, int height, Link link)
  {
    int dx = x + width;
    int dy = y + height;
    HRectangle hrect = new HRectangle(x,y,width,height,link);
    spots.addElement(hrect);
  }

  Link isHot(int x, int y)
  {
    // see if (x,y) is within any registered hot region
    // if so, return associated URL
    // otherwise, return null
    for(int i=0; i<spots.size(); i++) {
      HRegion hreg = (HRegion)spots.elementAt(i);
      if(hreg.isIn(x,y))
        return(hreg.link());
    }

    return(null);
  }

}
