import java.util.Date;
import java.io.*;

public class TmpFileCollector implements Runnable
{
  static public int DEFAULT_EXPIRATION_TIME = 60 ;  // 60min (1 hour)

  long sleepTime;         // miliseconds
  long expirationTime;    // ditto
  String tmpFileDir;

  TmpFileCollector(String tmpDirectory, int wakeupMinutes)
  {
    // verify if directory exists
    File f = new File(tmpDirectory);
    //if(!f.exists() || !f.isDirectory()) {
    //  System.out.println("erro: '" + tmpDirectory + "' nao existe ou nao e' diretorio");
    //  return;
    //}

    Thread t = new Thread(this, "TmpFileCollector");

    sleepTime = wakeupMinutes * 60 * 1000;
    expirationTime = sleepTime * 2;

    tmpFileDir = tmpDirectory;

    t.start();
  }

  TmpFileCollector(String tmpDirectory)
  {
    this(tmpDirectory, TmpFileCollector.DEFAULT_EXPIRATION_TIME);
  }

  public void run()
  {
    try {
      while(true) {
        Thread.sleep(sleepTime);

        // get current time
        //long now = System.currentTimeMillis();      // milliseconds
        Date now = new Date();

        // verify/delete, under directory 'tmpFileDir'
        // files created 'sleepTime' * 2 earlier
        File tmpImgDir = new File(tmpFileDir);
        if(tmpImgDir.isDirectory()) {
          String[] files = tmpImgDir.list();
          for(int i=0; i<files.length; i++) {
            File f = new File(tmpFileDir + "/" + files[i]);
            long lastModified = f.lastModified();   // milliseconds

            try {
              if(now.getTime() - lastModified >= expirationTime) {
                f.delete();
              }
            }
            catch(SecurityException e) {
              System.out.println("erro: nao foi possivel deletar '" + f.getAbsolutePath());
            }
          }
        }
        else {
          System.out.println("erro: '" + tmpFileDir + "' nao e' diretorio");
          break;
        }
      }
    }
    catch (InterruptedException e) {
    }
  }

  //public static void main(String[] args)
  //{
  //  new TmpFileCollector(3600 * 24 * 10, ".");
  //}

}
