-- ---------------------------------------------------------------------------------------------------------------------
-- PROJETOS.LUA
-- ---------------------------------------------------------------------------------------------------------------------
dofile( "lua/acessabd.lua" )
dofile( "lua/permissao_acesso.lua" )
dofile( "lua/global.lua" )
dofile( "lua/orgaos.lua" )
dofile( "lua/OT.lua" )
dofile( "lua/desempenho.lua" )

-- ----------------------------------------------------------------------------
-- Na tela com os campos de Dutos: 
-- 1. aceitar os campos numricos informando "," e no "." quando tem decimal. 
-- 2. exibir o zero antes da vrgula ex: 0,430 (errado: ,430)
-- 3. no exibir os zeros aps os nmeros inteiros.
-- ----------------------------------------------------------------------------
   function exibe_valor_duto(valor)
      -- ----------------------------------------------------------------------------
      -- Os valores de diametro, espessura e extensao devem ser impressos no formato 
      -- d*,dddd
      -- ----------------------------------------------------------------------------
         if valor and valor ~= '' and valor ~= .0000 then
         -- -------------------------------------------------------------------------	
         -- Substitui tudo o que no for dgito (nesse caso o ponto - . -) por 
         -- vrgula ( - , - )
         -- -------------------------------------------------------------------------   
            valor = gsub( valor, "%D", "," )
         elseif valor == .0000 then
            valor = '0'   
         end 
         
      -- ----------------------------------------------------------------------------
      -- Adiciona um zero antes da vrgula (EX: .987 -> 0,987)
      -- ----------------------------------------------------------------------------         
         if valor and valor ~= '' and valor ~= ' ' then
            ini, fim = strfind(valor,"%D")
            if ini == 1 then
               valor = '0'..valor   
            elseif ini then   
            -- ----------------------------------------------------------------------------
            -- Remove as casas decimais se o numero eh inteiro (EX: 10.0000 -> 10)
            -- ----------------------------------------------------------------------------               
               decimais = strsub(valor,ini+1) 
               if decimais == '0000' then
                  valor = strsub(valor,1,ini-1)
               end    
            end 
         end  
      return valor 
   end

function VersoesAnteriores( codigo, versao, pagina_func, pagina_chamadora)
  local resultado = ''
  if not( temConteudo(pagina_chamadora) ) then
     pagina_chamadora = ''
  end   
  DBExec ("SELECT proj_sigla FROM projeto WHERE proj_cod = "..codigo)
  local temp = DBRow()
  DBExec ("SELECT proj_cod FROM projeto WHERE last_versao = 's' AND proj_sigla = '"..temp.proj_sigla.."'")
  local temp1 = DBRow()
  DBExec ("SELECT proj_versao, proj_cod FROM projeto WHERE proj_sigla ='"..temp.proj_sigla.."' ORDER BY proj_versao, proj_cod")
  local temp2 = DBRow()
  while temp2 and temp2.proj_cod do               
    if temp2.proj_versao ~= versao then                 
       if temp2.proj_cod ~= temp1.proj_cod then          
          resultado = resultado.."<a href='result_consulta.html?cod="..temp2.proj_cod.."&tipo_servico=consulta&pagina_func="..pagina_func.."&pagina_chamadora="..pagina_chamadora.."&cod_last_versao="..temp1.proj_cod.."'>"..temp2.proj_versao.."</a>,&nbsp"
       else                          
          resultado = resultado.."<a href='"..pagina_func.."?pagina_chamadora="..pagina_chamadora.."&cod="..temp2.proj_cod.."'>"..temp2.proj_versao.."</a>,&nbsp"  
       end
    end
    temp2 = DBRow()
  end
  return strsub(resultado,0,(strlen(resultado)-6))    
end

function retornaFrequencia( cod ) 
   local consulta = "SELECT proj_freq FROM projeto WHERE proj_cod = "..cod
   if ESTADO_BD ~= 'aberto' then
      AbreBD()
   end
   DBExec(consulta)
   resultado = DBRow()
   return resultado.proj_freq   
end

function retornaNome( cod )
   local result = {}

   if ( cod ) then   
      result = ConsultaBD2( "projeto", "proj_nome", "proj_cod = '" .. cod .. "'" , nil )
      if ( not result[1][1] ) then
         result[1][1] = ''
      end
      return result[1][1]
   else
      return 'Cdigo de Projeto Invlido!'
   end
end

function retornaCodUsuarioProj ( cod )
   local result = {}
   
   if ( cod ) then
      result = ConsultaBD2( "projeto", "proj_cod_usuario", "proj_cod = '" .. cod .. "'" , nil )
      if ( not result[1][1] ) then
      	 result[1][1] = ''
      end
      return result[1][1]
   else
      return 'Cdigo do Projeto Invlido!'
   end
end

function retornaMetas ( cod )
   local result = {}
   
   if ( cod ) then
      result = ConsultaBD2( "projeto, meta", "meta_descr", "proj_cod = '" .. cod .. "' AND proj_meta= meta_cod", nil )
      if ( not result[1][1] ) then
         result[1][1] = ''
      end
      return result[1][1]
   else
      return 'Cdigo do Projeto Invlido!'
   end
end
   
function retornaOrgProj( cod )
   local result = {}

   if ( cod ) then
      result = ConsultaBD2( "projeto", "org_cod", "proj_cod = " .. cod, nil )
      if ( not result[1][1] ) then
         result[1][1] = ''
      end
      return result[1][1]
   else
      return 'Cdigo de Projeto Invlido!'
   end
end

function retornaDescrStat ( stat_cod )
   local result = {} 
   
   if ( stat_cod ) then   
      result = ConsultaBD2( "status", "stat_descr", "stat_cod = '" .. stat_cod .. "'" , nil )
      if ( not result[1][1] ) then
         result[1][1] = ''
      end
      return result[1][1]
   else
      return 'Cdigo da Situao Invlido!'
   end
   	
end

function retornaPrioridade( cod )
   local result = {}
   
   if ( cod ) then
      result = ConsultaBD2( "projeto", "proj_prior", "proj_cod = " .. cod .. "" , nil )
      if ( not result[1][1] ) then
         result[1][1] = ''
      end
      return result[1][1]
   else
      return 'Cdigo de Projeto Invlido!'
   end
end

function retornaDataInicioPrev( cod )
   local result = {}
   
   if ( cod ) then
      result = ConsultaBD2( "projeto", "proj_dt_ini_prev", "proj_cod = " .. cod .. "" , nil )
      if ( not result[1][1] ) then
         result[1][1] = ''
      end
      return result[1][1]
   else
      return 'Cdigo de Projeto Invlido!'
   end
end

function retornaDataFimPrev( cod )
   local result = {}
   
   if ( cod ) then
      result = ConsultaBD2( "projeto", "proj_dt_fim_prev", "proj_cod = '" .. cod .. "'" , nil )
      if ( not result[1][1] ) then
         result[1][1] = ''
      end
      return result[1][1]
   else
      return 'Cdigo de Projeto Invlido!'
   end
end

function retornaDataInicioReal( cod )
   local result = {}
   
   if ( cod ) then
      result = ConsultaBD2( "projeto", "proj_dt_ini_real", "proj_cod = '" .. cod .. "'" , nil )
      if ( not result[1][1] ) then
         result[1][1] = ''
      end
      return result[1][1]
   else
      return 'Cdigo de Projeto Invlido!'
   end
end

function retornaDataFimReal( cod )
   local result = {}
   
   if ( cod ) then
      result = ConsultaBD2( "projeto", "proj_dt_fim_real", "proj_cod = '" .. cod .. "'" , nil )
      if ( not result[1][1] ) then
         result[1][1] = ''
      end
      return result[1][1]
   else
      return 'Cdigo de Projeto Invlido!'
   end
end

function retornaCustoFim( cod )
   local result = {}
   
   if ( cod ) then
      result = ConsultaBD2( "custo", "sum(custo_prev_ano) AS custo_total", "proj_cod = '" .. cod .. "' GROUP BY proj_cod" , nil )
      if ( not result[1][1] ) then
         result[1][1] = ''
      end
      return result[1][1]
   else
      return 'Cdigo de Projeto Invlido!'
   end
end

function retornaVersao( cod )
   local result = {}
   
   if ( cod ) then
      result = ConsultaBD2( "projeto", "proj_versao", "proj_cod = '" .. cod .. "'" , nil )
      if ( not result[1][1] ) then
         result[1][1] = ''
      end
      return result[1][1]
   else
      return 'Cdigo de Projeto Invlido!'
   end
end

function retornaStatus( cod )
   local result = {}
   
   if ( cod ) then
      result = ConsultaBD2( "projeto", "stat_cod", "proj_cod = '" .. cod .. "'" , nil )
      if ( not result[1][1] ) then
         result[1][1] = ''
      end
      return result[1][1]
   else
      return 'Cdigo de Projeto Invlido!'
   end
end

-- Entrada: codigo do status
function retornaStatusDescr( cod )
   local result = {}
   
   if ( cod ) then
      result = ConsultaBD2( "status", "stat_descr", "stat_cod = '" .. cod .. "'" , nil )
     if ( not result[1][1] ) then
         result[1][1] = ''
      end
     return result[1][1]  
   else
      return 'Cdigo da Situao Invlido!'
   end
end

function retornaJustCancel( cod )
   local result = {}
   
   if ( cod ) then
     result = ConsultaBD2( "log", "log_justifica", "proj_cod = '" .. cod .. "'" , nil )
     if ( not result[1][1] ) then
         result[1][1] = ''
     end
     return result[1][1]  
   else
     return ' No h justificativa de cancelamento para o projeto!'      
   end
end

function retornaDataInclusao( cod )
   local result = {}
   
   if ( cod ) then
      result = ConsultaBD2( "projeto", "proj_dt_incl", "proj_cod = '" .. cod .. "'" , nil )
      if ( not result[1][1] ) then
         result[1][1] = ''
      end
      return result[1][1]
   else
      return 'Cdigo de Projeto Invlido!'
   end
end

function retornaDescricao( cod )
   local result = {}
   
   if ( cod ) then
      result = ConsultaBD2( "projeto", "proj_descr", "proj_cod = '" .. cod .. "'" , nil )
      if ( not result[1][1] ) then
         result[1][1] = ''
      end
      return result[1][1]
   else
      return 'Cdigo de Projeto Invlido!'
   end
end

function retornaUnidProj( cod )
   local result = {}

   if ( cod ) then   
      result = ConsultaBD2( "projeto", "unid_cod", "proj_cod = '" .. cod .. "'" , nil )
      if ( not result[1][1] ) then
         result[1][1] = ''
      end
      return result[1][1]
   else
      return 'Cdigo de Projeto Invlido!'
   end
end

function retornaNomeUnid( cod )
   local result = {}

   if ( cod ) then   
      result = ConsultaBD2( "unidade", "unid_nome", "unid_cod = '" .. cod .. "'" , nil )
      return result[1][1]
   else
      return 'Cdigo do rgo Invlido!'
   end
end

function retornaDesempenho( cod )
   local result = {}

   if ( cod ) then   
      result = ConsultaBD2( "desempenho", "desempenho_descr", "desempenho_cod = " .. cod , nil )
      return result[1][1]
   else
      return 'Cdigo de Desempenho Invlido!'
   end
end

-- ----------------------------------------------------------------------
-- Function : retornaDadosTranspetro
-- Description : Retorna uma tabela com os dados do projeto relacionados
--               a TRASPETRO
-- Parameters : 
--      cod : codigo do projeto
-- Return : 
--      tabela tbTranspetro que contem os dados do projeto relacionados a 
--      transpetro
-- ----------------------------------------------------------------------         
function retornaDadosTranspetro ( cod )
   local tbTranspetro = {} -- retorno
   local tbTemp = {} -- auxiliar
      
   tbTemp = ConsultaBD2( "transpetro", "*", "proj_cod = " .. cod, nil )
   
   if tbTemp then -- existe cadastro transpetro para esse projeto
      -- guardo na tabela de retorno os dados
      tbTranspetro.tipo = tbTemp[1].trans_tipo   
      tbTranspetro.eng = tbTemp[1].trans_eng
      tbTranspetro.cbi = tbTemp[1].trans_cbi
      tbTranspetro.cac = tbTemp[1].trans_cac
      tbTranspetro.cad = tbTemp[1].trans_cad
      tbTranspetro.ui = tbTemp[1].trans_ui
      tbTranspetro.prog = tbTemp[1].trans_prog
      tbTranspetro.proj = tbTemp[1].trans_proj
   end
   
   return tbTranspetro

end

-- Utilizada no acompanhento de projetos p/ o usuario fornecer as datas de fim e inicio real
function recebeDatasRealProj (cod)
   -- -------------------------------------------------------------------------------------------------
   -- DATA DE INICIO REAL DE PROJETO
   -- -------------------------------------------------------------------------------------------------
   dt_ini_real = formataData2(retornaDataInicioReal(cod))
   write( '<TR>\n' )
   write( '<TD><B><A HREF=Javascript:window.top.abre_hint("hint_Data_de_Inicio_Real_Acompanhamento_de_Projeto__")><font color=black>Data de Incio Real </font></a></B></TD>\n' )
   if cgi.DataInicioReal then
      write( '<TD><INPUT TYPE="text" MAXLENGTH="10" SIZE="8" NAME="DataInicioReal" VALUE="' .. cgi.DataInicioReal .. '" onChange="javascript:msgDataReal(\'DataInicioReal\');">(dd/mm/aaaa)</TD>\n' )
      write( '<TD><INPUT TYPE="hidden" NAME="DataInicioRealOld" VALUE="' ..dt_ini_real.. '"></TD>\n' )
   else
      write( '<TD><INPUT TYPE="text" MAXLENGTH="10" SIZE="8" NAME="DataInicioReal" VALUE="' ..dt_ini_real.. '" onChange="javascript:msgDataReal(\'DataInicioReal\');">(dd/mm/aaaa)</TD>\n' )
      write( '<TD><INPUT TYPE="hidden" NAME="DataInicioRealOld" VALUE="' ..dt_ini_real.. '"></TD>\n' )
   end   
   write( '</TR>\n' )     
   if cgi.msg_DataInicioReal then
      write( '<TR>\n' )
      write( '<TD>&nbsp;</TD>\n' )
      write( '<TD><FONT COLOR="red">'..cgi.msg_DataInicioReal..'</FONT></TD>\n' )
      write( '</TR>\n' )    
   elseif cgi.msg_dt_ini then
      write( '<TR>\n' )
      write( '<TD>&nbsp;</TD>\n' )
      write( '<TD><FONT COLOR="red">'.. cgi.msg_dt_ini..'</FONT></TD>\n' )
      write( '</TR>\n' )
   end
   
   -- -------------------------------------------------------------------------------------------------
   -- DATA DE FIM REAL DE PROJETO
   -- -------------------------------------------------------------------------------------------------      
   dt_fim_real = formataData2(retornaDataFimReal(cod))
   write( '<TR>\n' )
   write( '<TD><B><B><A HREF=Javascript:window.top.abre_hint("hint_Data_de_Termino_Real_Acompanhamento_de_Projeto__")><font color=black>Data de Trmino Real </font></a></B></TD>\n' )
   if cgi.DataFimReal then
      write( '<TD><INPUT TYPE="text" MAXLENGTH="10" SIZE="8" NAME="DataFimReal" VALUE="' .. cgi.DataFimReal .. '" onChange="javascript:msgDataReal(\'DataFimReal\');">(dd/mm/aaaa)\n' )
      write( '<TD><INPUT TYPE="hidden" MAXLENGTH="10" SIZE="8" NAME="DataFimRealOld" VALUE="' ..dt_fim_real.. '">\n' )
   else
      write( '<TD><INPUT TYPE="text" MAXLENGTH="10" SIZE="8" NAME="DataFimReal" VALUE="' ..dt_fim_real.. '" onChange="javascript:msgDataReal(\'DataFimReal\');">(dd/mm/aaaa)\n' )
      write( '<TD><INPUT TYPE="hidden" MAXLENGTH="10" SIZE="8" NAME="DataFimRealOld" VALUE="' ..dt_fim_real.. '">\n' )
   end                
   write( '</TD></TR>\n' )    
   if cgi.msg_DataFimReal then
      write( '<TR>\n' )
      write( '<TD>&nbsp;</TD>\n' )
      write( '<TD><FONT COLOR="red">'..cgi.msg_DataFimReal..'</FONT></TD>\n' )
      write( '</TR>\n' )    
   elseif cgi.msg_dt_fim then   
      write( '<TR>\n' )
      write( '<TD>&nbsp;</TD>\n' )
      write( '<TD><FONT COLOR="red">'..cgi.msg_dt_fim..'</FONT></TD>\n' )
      write( '</TR>\n' )    	
   end
end

-- Utilizada nas funcoes de formalizacao, revisao, cancelamento e conclusao
function mostraDatasRealProj (cod)
   dt_ini_real = formataData2(retornaDataInicioReal(cod))
   write( '<TR>\n' )
   write( '<TD><B>Data de Incio Real</B></TD>\n' )
   write( '<INPUT TYPE="hidden" NAME="dt_ini_real" VALUE="'..dt_ini_real..'">')
   write( '<TD>' ..dt_ini_real.. '</TD>' )   
   write( '</TR>\n' )
   
   dt_fim_real = formataData2(retornaDataFimReal(cod))
   write( '<TR>\n' )
   write( '<TD><B><B>Data de Trmino Real</B></TD>\n' )
   write( '<INPUT TYPE="hidden" NAME="dt_fim_real" VALUE="'..dt_fim_real..'">')
   write( '<TD>' ..dt_fim_real.. '</TD>' )
   write( '</TR>\n' )
end

-- ----------------------------------------------------------------------
-- usada para visualizar informaes de projetos no ACOMPANHAMENTO
-- ----------------------------------------------------------------------
function mostraInfoProj( cod, funcao, pagina_func, pagina_chamadora )    
   if ESTADO_BD ~= 'aberto' then
      AbreBD()
   end
   if not( temConteudo(cgi.tipo_servico) ) then
      cgi.tipo_servico = ''
   end   
   write( '<TABLE WIDTH="80%" BORDER="0" ALIGN="CENTER">')
   write( '<TR><TD><A HREF="cronog/cron_proj.html?proj_cod='..cod..'&pagina='..cgi.pagina..'&tipo_servico='..cgi.tipo_servico..'" ONMOUSEOVER=Over("cronogr"); ONMOUSEOUT=Out("cronogr");><IMG SRC="imagens/cronogr.gif" BORDER=0 NAME="cronogr"></A></TD></TR>\n')
   write( '<TR><TD><A HREF="curva/curvas.html?proj_cod='..cod..'&pagina='..cgi.pagina..'&tipo_servico='..cgi.tipo_servico..'&realizacao=financeira" ONMOUSEOVER=Over("curvfinanceira"); ONMOUSEOUT=Out("curvfinanceira");><IMG SRC="imagens/curvfinanceira.gif" BORDER=0 NAME="curvfinanceira"></A></TD></TR>\n')
   write( '<TR><TD><A HREF="curva/curvas.html?proj_cod='..cod..'&pagina='..cgi.pagina..'&tipo_servico='..cgi.tipo_servico..'&realizacao=fisica" ONMOUSEOVER=Over("curvfisica_nov"); ONMOUSEOUT=Out("curvfisica_nov");><IMG SRC="imagens/curvfisica_nov.gif" BORDER=0 NAME="curvfisica_nov"></A></TD></TR>\n')   
   write( '<TR><TD><A HREF=javascript:FollowUp("lista_follow_up.html?proj_cod='..cod..'") ONMOUSEOVER=Over("followup"); ONMOUSEOUT=Out("followup");><IMG SRC="imagens/followup.gif" BORDER=0 NAME="followup"></A></TD></TR>\n')

   cod_user = retornaCodUsuarioProj ( cod )  
   write( '<TR>\n')
   write( '<TD><B>Cdigo do Projeto</B></TD>\n' )
   write( '<TD>' .. cod_user..'</TD>\n' )
   write( '</TR>\n' )
   
   write( '<TR>\n' )
   write( '<TD valign="top"><B>Nome do Projeto</B></TD>\n' )
   write( '<TD>' .. retornaNome(cod) .. '</TD>\n' )
   write( '</TR>\n' )
   
   write( '<TR>\n' )
   write( '<TD><B>Nome da rea de Negcio</B></TD>\n' )
   write( '<TD>' .. retornaNomeOrg(retornaOrgProj ( cod )) .. '</TD>\n' )
   write( '</TR>\n' )
   
   write( '<TR>\n' )
   write( '<TD><B>Responsvel da rea de Negcio</B></TD>\n' )
   write( '<TD>' .. retornaRespOrg(retornaOrgProj ( cod )) .. '</TD>\n' )
   write( '</TR>\n' )
   
   write( '<TR>\n' )
   write( '<TD><B>Nome da Unidade de Negcio</B></TD>\n' )
   write( '<TD>' .. retornaNomeUnid(retornaUnidProj ( cod )) .. '</TD>\n' )
   write( '</TR>\n' )
   
   write( '<TR>\n' )
   write( '<TD><B>Responsvel da Unidade de Negcio</B></TD>\n' )
   write( '<TD>' .. retornaRespUnid(retornaUnidProj ( cod )) .. '</TD>\n' )
   write( '</TR>\n' )  

   sql = "select * from projeto a, orgao b where a.proj_cod = "..cod.." and a.org_cod = b.org_cod"
   DBExec(sql)
   orgao = DBRow()
   if orgao.org_sigla == 'TRANSPETRO' then
   
      sql = "SELECT b.ger_sigla FROM projeto a,gerencia b WHERE proj_cod = "..cod.." AND a.ger_cod = b.ger_cod"
      DBExec(sql)
      dados = DBRow()
      if dados then
         write( '<TR>\n' )
         write( '<TD><B>Nome da Ger&ecirc;ncia</B></TD>\n' )
         write( '<TD>'..dados.ger_sigla..'</TD>\n' )
         write( '</TR>\n' )
      end
      
      sql = "select b.set_sigla from projeto a,setor b where proj_cod = "..cod.." and a.set_cod = b.set_cod"
      DBExec(sql)
      dados_set = DBRow()
      if dados_set then
         write( '<TR>\n' )
         write( '<TD><B>Nome do Setor</B></TD>\n' )
         write( '<TD>'..dados_set.set_sigla..'</TD>\n' )
         write( '</TR>\n' )
      end
   end

--- classificacao   
   write( '<TR>\n' )
   write( '<TD><B>Classificao</B></TD>\n' )
   write( '<TD>' .. retornaNomeClas(retornaCodClasProj ( cod )) .. '</TD>\n' )
   write( '</TR>\n' )

--- ot clas
   write( '<TR>\n' )
   write( '<TD><B>OT Classificao</B></TD>\n' ) 
   write( '<TD>' .. retornaOTClas(retornaCodOTClasProj( cod )) .. '</TD>\n' )
   write( '</TR>\n' )
   
--- subclassificacao ( apenas se existir para a classificao escolhida)
   subclas = retornaNomeClas(retornaCodSubClasProj ( cod ))
   if ( subclas and subclas ~= nil) then
      write( '<TR>\n' )
      write( '<TD><B>Subclassificao</B></TD>\n' )
      write( '<TD>' .. retornaNomeClas(retornaCodSubClasProj ( cod )) .. '</TD>\n' )
      write( '</TR>\n' )

--- ot subclas
      write( '<TR>\n' )
      write( '<TD><B>OT Subclassificao</B></TD>\n' )
      write( '<TD>' .. retornaOTClas(retornaCodOTSubClasProj( cod )) .. '</TD>\n' )
      write( '</TR>\n' )
   end
  
--- metas
   meta = retornaMetas ( cod )  
   write( '<TR>\n')
   write( '<TD><B>Metas</B></TD>\n' )
   write( '<TD>' .. meta .. '</TD>\n' )
   write( '</TR>\n' )
     
--- ot operacional   
   write( '<TR>\n' )
   write( '<TD><B>OT Operacional</B></TD>\n' )
   write( '<TD>' .. retornaOTOper(retornaCodOTOperProj( cod )) .. '</TD>\n' )
   write( '</TR>\n' )

--- ot especfica
   ot_esp = retornaOtEspProj ( cod )
   write( '<TR>\n' )
   write( '<TD><B>OT Especfica</B></TD>\n' )
   write( '<TD>' .. ot_esp..'</TD>\n' )
   write( '</TR>\n' )

   consulta_colaboradores = "SELECT * FROM colaboradores as c, pessoal as p WHERE c.proj_cod = "..tonumber(cod).." AND c.colaborador = p.pes_cod ORDER BY p.pes_nguerra"
   DBExec(consulta_colaboradores)
   resultado_colaboradores = DBRow()
   if resultado_colaboradores and resultado_colaboradores.pes_chave then
      tab_colaboradores = {}
      local z = 1
      while resultado_colaboradores do
         tab_colaboradores[z] = resultado_colaboradores
         z = z + 1
         resultado_colaboradores = DBRow()
      end
   end
   
   consulta_projeto = "SELECT * FROM projeto as proj, pessoal as pes WHERE proj.proj_cod = "..tonumber(cod)
   DBExec(consulta_projeto)
   resultado_projeto = DBRow()
   if resultado_projeto and resultado_projeto.proj_coord then
      coordenador = resultado_projeto.proj_coord
   else
      coordenador = ''
   end
   if resultado_projeto and resultado_projeto.proj_colab then
      colaborador = resultado_projeto.proj_colab
   else
      colaborador = ''
   end
   
--- coordenador 
   write( '<TR>\n' )
   write( '<TD><B>Coordenador</B></TD>\n' )
   if resultado_projeto and resultado_projeto.proj_coord then
      write( '<TD>' .. coordenador..'</TD>\n' )
   end
   write( '</TR>\n' ) 
   
--- colaborador
   write( '<TR>\n' )
   write( '<TD><B>Colaborador</B></TD>\n' )
   if resultado_projeto and resultado_projeto.proj_colab then
      select = "SELECT * FROM pessoal WHERE pes_chave = '"..colaborador.."'"
      DBExec(select)
      resultado = DBRow()
      write( '<TD>'..resultado.pes_nguerra..' (' .. colaborador..')</TD>\n' )
   end
   write( '</TR>\n' )
   
--- outros colaboradores
   write( '<TR>\n' )
   write( '<TD VALIGN="top"><B>Outros Colaboradores</B></TD>\n' )
   z = 1
   if tab_colaboradores and tab_colaboradores[z].pes_chave then
      write( '<TD>' )
      while tab_colaboradores[z] do
         write( ''..tab_colaboradores[z].pes_nguerra..' (' ..tab_colaboradores[z].pes_chave..')<BR>\n' )
         z = z + 1
      end
      write( '</TD>' )
   end
   write( '</TR>\n' )

-- Plano de Recuperao   
   write( '<TR>\n' )
   write( '<TD><B>Plano de Recuperao</B></TD>\n' )
   if resultado_projeto and resultado_projeto.proj_plano_rec == 1 then
      plano_recuperacao = "Sim"
   elseif resultado_projeto and resultado_projeto.proj_plano_rec == 0 then
      plano_recuperacao = "No"
   else 
      plano_recuperacao = ""
   end
   write( '<TD>' .. plano_recuperacao .. '</TD>\n' )
   write( '</TR>\n' )               

   -- Plano emergencial de integridade de dutos
   if resultado_projeto and resultado_projeto.proj_paeid then
      write( '<TR>\n' )
      write( '<TD><B>Plano emergencial de integridade de dutos</B></TD>\n' )
      if resultado_projeto.proj_paeid == 1 then
         plano_emergencial_dutos = "Sim"
      else
         plano_emergencial_dutos = "No"
      end
      write( '<TD>' .. plano_emergencial_dutos .. '</TD>\n' )
      write( '</TR>\n' )     
   end
   
   -- Classificao do acompanhamento do projeto
   write( '<TR>\n' )
   write( '<TD><B>Classificao do acompanhamento do projeto</B></TD>\n' )
   if resultado_projeto and resultado_projeto.proj_class then
      if resultado_projeto and resultado_projeto.proj_class == 1 then
         class_acomp = "I"
      end
      if resultado_projeto and resultado_projeto.proj_class == 2 then
         class_acomp = "II"
      end
      if resultado_projeto and resultado_projeto.proj_class == 3 then
         class_acomp = "III"
      end
      write( '<TD>' .. class_acomp .. '</TD>\n' )
   else
      write( '<TD>Sem classificao</TD>\n' )
   end
   write( '</TR>\n' )

   -- Frequencia de Follow-Up
   write( '<TR>\n' )
   write( '<TD><B>Frequncia de Follow-Up</B></TD>\n' )
   write( '<TD>' .. retornaFrequencia(cod) .. '</TD>\n' )
   write( '</TR>\n' ) 
   
   -- Prioridade  
   write( '<TR>\n' )
   write( '<TD><B>Prioridade</B></TD>\n' )
   write( '<TD>' .. retornaPrioridade(cod) .. '</TD>\n' )
   write( '</TR>\n' )                      
   
   pertence = Pertence()
   if pertence == "SIM" then
      
      local tab = {}
      tab = ConsultaBD2("orgao a, pessoal b","b.pes_chave","b.pes_cod = a.org_cod AND a.org_sigla = 'TRANSPETRO'",nil)
      
      -- Usuario da maquina
      local curr_user 
      curr_user = getuser()
                   
      local tabela = {}  
      tabela = retornaDadosTranspetro( cod ) 

      write( '<TR>\n' )
      write( '<TD><B>Engenharia</B></TD>\n' )
      if tabela.eng == 'S' then
         write( '<TD>Sim</TD>\n' )
      elseif tabela.eng == 'N' then
         write( '<TD>No</TD>\n' )      
      end
      write( '</TR>\n' )            
      write( '<TR>\n' )
      write( '<TD><B>Tipo</B></TD>\n' )
      if tabela.tipo == '1' then
         write( '<TD>Operao</TD>\n' )
      elseif tabela.tipo == '0' then
         write( '<TD>Investimento</TD>\n' )      
      end      
      write( '</TR>\n' )     
      write( '<TR>\n' )
      write( '<TD><B>CAC</B></TD><TD>' .. troca_nil_por_vazio(tabela.cac) .. '</TD></TR>' )
      write( '<TR><TD><B>CAD</B></TD><TD>' .. troca_nil_por_vazio(tabela.cad) .. '</TD></TR>' )
      write( '<TR><TD><B>CBI</B></TD><TD>' .. troca_nil_por_vazio(tabela.cbi) .. '</TD></TR>' )
      write( '<TR><TD><B>UI</B></TD><TD>' .. troca_nil_por_vazio(tabela.ui) .. '</TD></TR>' )
      write( '<TR><TD><B>Programa</B></TD><TD>' .. troca_nil_por_vazio(tabela.prog) .. '</TD></TR>' )
      write( '<TR><TD><B>Projeto</B></TD><TD>' .. troca_nil_por_vazio(tabela.proj) .. '</TD>\n' )      
      write( '</TR>\n' )                         
   end 
   
-- ----------------------------------------------------------------   
-- CAMPOS REFERENTES AO Plano emergencial de integridade de dutos --
-- ----------------------------------------------------------------
   if plano_emergencial_dutos == "Sim" then        
      sql = "SELECT * FROM dutos WHERE proj_cod = "..tonumber(cod)
      DBExec(sql)
      dados_dutos = DBRow()
   
      if not dados_dutos then
         -- Dimetro
         write( '<TR>\n' )
         write( '<TD><B>Dimetro </B></TD>\n' )
         write( '<TD>&nbsp;</TD>\n' )
         write( '</TR>\n' )
         
         -- Espessura
         write( '<TR>\n' )
         write( '<TD><B>Espessura </B></TD>\n' )
         write( '<TD>&nbsp;</TD>\n' )
         write( '</TR>\n' )
         
         -- Extenso
         write( '<TR>\n' )
         write( '<TD><B>Extenso</B></TD>\n' )
         write( '<TD>&nbsp;</TD>\n' )
         write( '</TR>\n' )
         
         -- Materiais
         write( '<TR>\n' )
         write( '<TD><B>Materiais</B></TD>\n' )
         write( '<TD>&nbsp;</TD>\n' )
         write( '</TR>\n' )
         
         -- Origem
         write( '<TR>\n' )
         write( '<TD><B>Origem </B></TD>\n' )
         write( '<TD>&nbsp;</TD>\n' )
         write( '</TR>\n' )
         
         -- Destino
         write( '<TR>\n' )
         write( '<TD><B>Destino </B></TD>\n' )
         write( '<TD>&nbsp;</TD>\n' )
         write( '</TR>\n' )
         
         -- Produto
         write( '<TR>\n' )
         write( '<TD><B> Produto </B></TD>\n' )
         write( '<TD>&nbsp;</TD>\n' )
         write( '</TR>\n' )
         
         -- Outras Caractersticas
         write( '<TR>\n' )
         write( '<TD valign = "top"><B>Outras Caractersticas </B></TD>\n' )
         write( '<TD>&nbsp;</TD>\n' )
         write( '</TR>\n' )      
      else
         -- Dimetro
         if not dados_dutos.duto_diametro then
            dados_dutos.duto_diametro = ""
         end   	
         write( '<TR>\n' )
         write( '<TD><B>Dimetro </B></TD>\n' )
         if tonumber(dados_dutos.duto_diametro) == 0 then
            dados_dutos.duto_diametro = ""
         end
         write( '<TD>'..exibe_valor_duto(dados_dutos.duto_diametro)..'</TD>\n' )
         write( '</TR>\n' )
         
         -- Espessura
         if not dados_dutos.duto_espessura then
            dados_dutos.duto_espessura = ""
         end
         write( '<TR>\n' )
         write( '<TD><B>Espessura </B></TD>\n' )
         if tonumber(dados_dutos.duto_espessura) == 0 then
            dados_dutos.duto_espessura = ""
         end      
         write( '<TD>'..exibe_valor_duto(dados_dutos.duto_espessura)..'</TD>\n' )
         write( '</TR>\n' )
         
         -- Extenso
         if not dados_dutos.duto_extensao then
            dados_dutos.duto_extensao = ""
         end
         write( '<TR>\n' )
         write( '<TD><B>Extenso</B></TD>\n' )
         if tonumber(dados_dutos.duto_extensao) == 0 then
            dados_dutos.duto_extensao = ""
         end      
         write( '<TD>'..exibe_valor_duto(dados_dutos.duto_extensao)..'</TD>\n' )
         write( '</TR>\n' )
         
         -- Materiais
         if not dados_dutos.duto_materiais then
            dados_dutos.duto_materiais = ""
         end
         write( '<TR>\n' )
         write( '<TD><B>Materiais</B></TD>\n' )
         write( '<TD>'..dados_dutos.duto_materiais..'</TD>\n' )
         write( '</TR>\n' )
         
         -- Origem
         if not dados_dutos.duto_origem then
            dados_dutos.duto_origem = ""
         end
         write( '<TR>\n' )
         write( '<TD><B>Origem </B></TD>\n' )
         write( '<TD>'..dados_dutos.duto_origem..'</TD>\n' )
         write( '</TR>\n' )
         
         -- Destino
         if not dados_dutos.duto_destino then
            dados_dutos.duto_destino = ""
         end
         write( '<TR>\n' )
         write( '<TD><B>Destino </B></TD>\n' )
         write( '<TD>'..dados_dutos.duto_destino..'</TD>\n' )
         write( '</TR>\n' )
         
         -- Produto
         if not dados_dutos.duto_produto then
            dados_dutos.duto_produto = ""
         end
         write( '<TR>\n' )
         write( '<TD><B> Produto </B></TD>\n' )
         write( '<TD>'..dados_dutos.duto_produto..'</TD>\n' )
         write( '</TR>\n' )
         
         -- Outras Caractersticas
         if not dados_dutos.duto_outras then
            dados_dutos.duto_outras = ""
         end
         write( '<TR>\n' )
         write( '<TD valign = "top"><B>Outras Caractersticas </B></TD>\n' )        
         write( '<TD>')
         -- Dah break no texto de acordo com o numero de caracteres da quebra (nesse caso 70) e imprime o texto         
         QuebraLinha(dados_dutos.duto_outras,70)   
         write('&nbsp;</TD>\n' )
         write( '</TR>\n' )
      end
   end
   
   -- Data de Inclusao
   write( '<TR>\n' )
   write( '<TD><B>Data de Incluso</B></TD>\n' )
   write( '<TD>' .. formataData(retornaDataInclusao(cod)) .. '</TD>\n' )
   write( '</TR>\n' )
   dados = DadosProjeto(cod)
   
   -- Data de Formalizacao
   write( '<TR>\n' )
   write( '<TD><B>Data de Formalizao</B></TD>\n' )
   if dados.proj_dt_form then
      write( '<TD>' ..formataData(dados.proj_dt_form).. '</TD>\n' )
   else
      write( '<TD>&nbsp</TD>\n' )
   end
   write( '</TR>\n' )

   -- Data de Conclusao
   write( '<TR>\n' )
   write( '<TD><B>Data de Concluso</B></TD>\n' )
   if dados.proj_dt_conc then
      write( '<TD>'..formataData(dados.proj_dt_conc)..'</TD>\n' )
   else
      write( '<TD>&nbsp</TD>\n' )
   end
   write( '</TR>\n' )

   -- Data Inicio Previsto
   write( '<TR>\n' )
   write( '<TD><B>Data de Incio Previsto</B></TD>\n' )
   write( '<TD>' .. formataData(retornaDataInicioPrev(cod)) .. '</TD>\n' )
   write( '</TR>\n' )

   -- Data Termino Previsto
   write( '<TR>\n' )
   write( '<TD><B>Data de Trmino Previsto</B></TD>\n' )
   write( '<TD>' .. formataData(retornaDataFimPrev(cod)) .. '</TD>\n' )
   write( '</TR>\n' )
   
   if temConteudo(funcao) and funcao == 'acompanha' then  
      recebeDatasRealProj (cod)
   else
      mostraDatasRealProj (cod)
   end
   
   -- Versao
   write( '<TR>\n' )
   write( '<TD><B>Verso</B></TD>\n' )
   write( '<TD>' .. retornaVersao(cod) .. '</TD>\n' )
   -- Informacao passada p/ a pagina de revisao
   write( '<INPUT TYPE="hidden" NAME="versao" VALUE="'..retornaVersao(cod)..'">')
   versoes = VersoesAnteriores(cod, retornaVersao(cod), pagina_func, pagina_chamadora)
   if temConteudo( versoes ) then
      write( '</TR><TR><TD><b>Outras Verses</b></TD><TD>' ..versoes.. '</TD>\n' )
   end
   write( '</TR>\n' )
  -- exit()
   -- Situacao
   write( '<TR>\n' )
   write( '<TD><B>Situao</B></TD>\n' )
   write( '<TD>' .. retornaStatusDescr(retornaStatus(cod)) .. '</TD>\n' )
   write( '</TR>\n' )
    
   -- Justificativa de Cancelamento
   if retornaStatusDescr(retornaStatus(cod)) == 'Cancelado' then
      write( '<TR>\n' )
      write( '<TD><B>Justificativa do Cancelamento</B></TD>\n' )
      write( '<TD>' .. retornaJustCancel(cod) .. '</TD>\n' )
      write( '</TR>\n' )
   end	
   
   -- Descricao
   if retornaDescricao(cod) == "NULL" then
      descricao = ""
   else
      descricao = retornaDescricao(cod)
   end
   write( '<TR>\n' )
   write( '<TD valign="top"><B>Descrio</B></TD>\n' )
   write( '<TD>' .. descricao .. '</TD>\n' )
   write( '</TR>\n' )
   
   -- Custo Final Previsto
   write( '<TR>\n' )
   write( '<TD><B>Custo Final Previsto</B></TD>\n' )
   -- -----------------------------------------------------------------------------------------------------
   -- Se o valor de retornaCustoFim(cod) no existir ou existir e for vazio, quando passado para a funo
   -- FORMATA_VALOR() [ formata_valor(retornaCustoFim(cod)) ] ocasionar um erro
   -- Portanto,  necessrio que se verifique o valor de retornaCustoFim(cod) previamente
   -- -----------------------------------------------------------------------------------------------------
   if temConteudo(retornaCustoFim(cod)) then
      write( '<TD>R$ ' .. ponto_centavo(formata_valor(retornaCustoFim(cod))) .. '</TD>\n' )
   else   
      write( '<TD>0,00</TD>\n' )
   end    
   write( '</TR>\n' )
   write( '</TABLE>\n')
      
   if ESTADO_BD == 'aberto' then
      FechaBD()
   end
   
end

function ordenaCampos ( tab_projs )  
   tab_info  = Separa_Variaveis(cgi.recebe_informacoes)
   local k = 1   
   if ESTADO_BD ~= 'aberto' then
      AbreBD()
   end
   write('<table border="0">')   
   while tab_info[k] do 
      if tab_info[k] == 'area_negocio' then
         if not tab_projs.org_cod or tab_projs.org_cod == '' then
            write ( '<TR><TD><B>rea de Negcio: </B>-</TD></TR>\n' )
         else 
            local consulta = "SELECT org_sigla FROM orgao WHERE org_cod = "..tab_projs.org_cod
            DBExec(consulta)
            local resultado = DBRow()  
            write ( '<TR><TD><B>rea de Negcio: </B>',resultado.org_sigla,'</TD></TR>\n' )
         end
      end     
      if tab_info[k] == 'resp_an' then
         if not tab_projs.org_cod or tab_projs.org_cod == '' then
            write ( '<TR><TD><B>Responsvel pela AN: </B>-</TD></TR>\n' )
         else 
            local consulta = "SELECT p.pes_nome, p.pes_chave FROM orgao as o, pessoal as p WHERE o.org_cod = " ..
                             "" .. tab_projs.org_cod .. " AND o.pes_cod_resp = p.pes_cod"
            DBExec(consulta)
            local resultado = DBRow()                       
            write ( '<TR><TD><B>Responsvel pela AN: </B>',resultado.pes_nome,'(<I>',resultado.pes_chave,'</I>)</TD></TR>\n' )
         end
      end   
      if tab_info[k] == 'unidade_negocio' then
         if not tab_projs.unid_cod or tab_projs.unid_cod == '' then
            write ( '<TR><TD><B>Unidade de Negcio: </B>-</TD></TR>\n' )
         else 
            local consulta = "SELECT unid_sigla FROM unidade WHERE unid_cod = "..tab_projs.unid_cod
            DBExec(consulta)
            local resultado = DBRow()                       
            write ( '<TR><TD><B>Unidade de Negcio: </B>',resultado.unid_sigla,'</TD></TR>\n' )
         end
      end   
      if tab_info[k] == 'resp_un' then
         if not tab_projs.unid_cod or tab_projs.unid_cod == '' then
            write ( '<TR><TD><B>Responsvel pela UN: </B>-</TD></TR>\n' )
         else 
            local consulta = "SELECT p.pes_nome, p.pes_chave FROM unidade as u, pessoal as p WHERE u.unid_cod = " ..
                             "" .. tab_projs.unid_cod .. " AND u.pes_cod_resp = p.pes_cod"
            DBExec(consulta)
            local resultado = DBRow()                       
            write ( '<TR><TD><B>Responsvel pela UN: </B>',resultado.pes_nome,'(<I>',resultado.pes_chave,'</I>)</TD></TR>\n' )
         end
      end         
      if tab_info[k] == 'gerencia' then
         if not tab_projs.ger_cod or tab_projs.ger_cod == '' then
            write ( '<TR><TD><B>Gerncia: </B>-</TD></TR>\n' )
         else 
            local consulta = "SELECT ger_sigla FROM gerencia WHERE ger_cod = "..tab_projs.ger_cod
            DBExec(consulta)
            local resultado = DBRow()                       
            write ( '<TR><TD><B>Gerncia: </B>',resultado.ger_sigla,'</TD></TR>\n' )
         end
      end   
      if tab_info[k] == 'classificacao' then
         local consulta = "SELECT a.clas_descr FROM classificacao a, proj_ot b WHERE b.proj_cod = "..tab_projs.proj_cod.." AND b.clas_cod = a.clas_cod"
         DBExec(consulta)
         local resultado = DBRow()  
         if resultado and resultado.clas_descr then
            write ( '<TR><TD><B>Classificao: </B>',resultado.clas_descr,'</TD></TR>\n' )
         else
            write ( '<TR><TD><B>Classificao: </B>-</TD></TR>\n' )
         end
      end           
      if tab_info[k] == 'subclassificacao' then
         local consulta = "SELECT a.clas_descr FROM classificacao a, proj_ot b WHERE b.proj_cod = "..tab_projs.proj_cod.." AND b.proj_ot_subcl_cod = a.clas_cod"
         DBExec(consulta)
         local resultado = DBRow()  
         if resultado and resultado.clas_descr then
            write ( '<TR><TD><B>Sub-Classificao: </B>',resultado.clas_descr,'</TD></TR>\n' )
         else
            write ( '<TR><TD><B>Sub-Classificao: </B>-</TD></TR>\n' )
         end
      end      
      if tab_info[k] == 'meta' then
         local consulta = "SELECT meta_descr FROM projeto as p, meta as m WHERE p.proj_cod = " .. tab_projs.proj_cod .. "" ..
                          " AND p.proj_meta = m.meta_cod"
         DBExec(consulta)
         local resultado = DBRow()           
         if resultado and resultado.meta_descr then
            write ( '<TR><TD><B>Meta: </B>',resultado.meta_descr,'</TD></TR>\n' )
         else
            write ( '<TR><TD><B>Meta: </B>-</TD></TR>\n' )
         end
      end           
      if tab_info[k] == 'prioridade' then
         if not tab_projs.proj_prior or tab_projs.proj_prior == '' then
            write ( '<TR><TD><B>Prioridade: </B>-</TD></TR>\n' )
         else 
            write ( '<TR><TD><B>Prioridade: </B>',tab_projs.proj_prior,'</TD></TR>\n' )
         end
      end     
      if tab_info[k] == 'codigo_projeto' then
         if not tab_projs.proj_cod_usuario or tab_projs.proj_cod_usuario == '' then
            write ( '<TR><TD><B>Cdigo do Projeto: </B>-</TD></TR>\n' )
         else 
            write ( '<TR><TD><B>Cdigo do Projeto: </B>',tab_projs.proj_cod_usuario,'</TD></TR>\n' )
         end      
      end
      
      if tab_info[k] == 'status' then
         if not tab_projs.stat_cod or tab_projs.stat_cod == '' then
            write ( '<TR><TD><B>Situao: </B>-</TD></TR>\n' )
         else            
            write ( '<TR><TD><B>Situao: </B>',tab_projs.stat_descr,'</TD></TR>\n' )
         end
      end                
      if tab_info[k] == 'plano_rec' then
         if not tab_projs.proj_plano_rec or tab_projs.proj_plano_rec == '' then
            write ( '<TR><TD><B>Plano de Recuperao: </B>-</TD></TR>\n' )
         else       
            if tonumber(tab_projs.proj_plano_rec) == 1 then
               plano_rec = 'Sim'
            else
               plano_rec = 'No'                     
            end 
            write ( '<TR><TD><B>Plano de Recuperao: </B>',plano_rec,'</TD></TR>\n' )              
         end
      end      
      if tab_info[k] == 'classacomp' then
         if not tab_projs.proj_class or tab_projs.proj_class == '' then
            write ( '<TR><TD><B>Classificao do Acompanhamento: </B>-</TD></TR>\n' )
         else 
            if tonumber(tab_projs.proj_class) == 1 then
               proj_class = 'I'
            elseif tonumber(tab_projs.proj_class) == 2 then
               proj_class = 'II'
            elseif tonumber(tab_projs.proj_class) == 3 then
               proj_class = 'III'            
            end
            write ( '<TR><TD><B>Classificao do Acompanhamento: </B>',proj_class,'</TD></TR>\n' )
         end
      end      
      if tab_info[k] == 'dt_ini_prev' then
         if not( temConteudo(tab_projs.proj_dt_ini_prev) ) then
            write ( '<TR><TD><B>Data de Incio Previsto: </B>-</TD></TR>\n' )
         else 
            write ( '<TR><TD><B>Data de Incio Previsto: </B>',formataData(tab_projs.proj_dt_ini_prev),'</TD></TR>\n' )
         end
      end                                                                                                             
      if tab_info[k] == 'dt_fim_prev' then
         if not( temConteudo(tab_projs.proj_dt_fim_prev) ) then
            write ( '<TR><TD><B>Data de Trmino Previsto: </B>-</TD></TR>\n' )
         else 
            write ( '<TR><TD><B>Data de Trmino Previsto: </B>',formataData(tab_projs.proj_dt_fim_prev),'</TD></TR>\n' )
         end
      end        
      if tab_info[k] == 'dt_ini_real' then
         if not( temConteudo(tab_projs.proj_dt_ini_real) ) then
            write ( '<TR><TD><B>Data de Incio Realizado: </B>-</TD></TR>\n' )
         else 
            write ( '<TR><TD><B>Data de Incio Realizado: </B>',formataData2(tab_projs.proj_dt_ini_real),'</TD></TR>\n' )
         end
      end        
      if tab_info[k] == 'dt_fim_real' then
         if not( temConteudo(tab_projs.proj_dt_fim_real) ) then
            write ( '<TR><TD><B>Data de Trmino Realizado: </B>-</TD></TR>\n' )
         else 
            write ( '<TR><TD><B>Data de Trmino Realizado: </B>',formataData2(tab_projs.proj_dt_fim_real),'</TD></TR>\n' )
         end
      end                                                              
      if tab_info[k] == 'tipo' then
         local consulta = "SELECT trans_tipo FROM transpetro WHERE proj_cod = "..tab_projs.proj_cod
         DBExec(consulta)
         local resultado = DBRow()
         if not resultado or not resultado.trans_tipo then
            write ( '<TR><TD><B>Tipo: </B>-</TD></TR>\n' )
         else 
            if tonumber(resultado.trans_tipo) == 0 then
               write ( '<TR><TD><B>Tipo: </B>Investimento</TD></TR>\n' )
            else
               write ( '<TR><TD><B>Tipo: </B>Operao</TD></TR>\n' )            
            end
         end      
      end
      if tab_info[k] == 'atividades' then
         local resultado = ConsultaBD2("atividade","*","proj_cod = " .. tab_projs.proj_cod, "ativ_dt_ini_prev,ativ_nome")         
         local o = 1
         if resultado[o] and resultado[o].ativ_cod then
            write ( '</TABLE><TABLE border="0">' )
            write ( '<TR><TD colspan="8"><B>Atividades: </B></TD></TR>' )
            write ( '<TR><TD><b>Nome da Atividade</TD><TD><b>Data de Incio Prevista</TD>' )
            write ( '<TD><b>Data de Trmino Prevista</TD><TD><b>Data de Incio Realizada</TD><TD><b>Data de Trmino Realizada</TD>' )
            write ( '<TD><b>Peso da Atividade</TD><TD><b>% Realizado<br>(% Esperado)</b></TD><TD><b>% Realizado no Projeto (% Esperado)</TD></TR>' )
            local hoje = date("%Y%m%d")
            while resultado[o] do
               if resultado[o].ativ_nome then
                  ativ_nome = resultado[o].ativ_nome
               else
                  ativ_nome = ''
               end
               if resultado[o].ativ_dt_ini_prev then
                  ativ_dt_ini_prev = resultado[o].ativ_dt_ini_prev
               else
                  ativ_dt_ini_prev = ''
               end               
               if resultado[o].ativ_dt_fim_prev then
                  ativ_dt_fim_prev = resultado[o].ativ_dt_fim_prev
               else
                  ativ_dt_fim_prev = ''
               end  
               if resultado[o].ativ_dt_ini_real then
                  ativ_dt_ini_real = resultado[o].ativ_dt_ini_real
               else
                  ativ_dt_ini_real = ''
               end                                              
               if resultado[o].ativ_dt_fim_real then
                  ativ_dt_fim_real = resultado[o].ativ_dt_fim_real
               else
                  ativ_dt_fim_real = ''
               end   
               if resultado[o].ativ_peso_rel_proj then
                  ativ_peso_rel_proj = resultado[o].ativ_peso_rel_proj
               else
                  ativ_peso_rel_proj = ''
               end    
               if resultado[o].ativ_perc_real then
                  ativ_perc_real = resultado[o].ativ_perc_real
               else
                  ativ_perc_real = 0
               end                                                            
               write( '<TR>' )
               write( '<TD>',ativ_nome,'</TD>' )
               write( '<TD>',formataData2(ativ_dt_ini_prev),'</TD>' )
               write( '<TD>',formataData2(ativ_dt_fim_prev),'</TD>' )
               write( '<TD>',formataData2(ativ_dt_ini_real),'</TD>' )
               write( '<TD>',formataData2(ativ_dt_fim_real),'</TD>' )
               write( '<TD>',ativ_peso_rel_proj,'</TD>' )
               
               DBExec("select tipo_curva from orgao, projeto "..
                      "where orgao.org_cod=projeto.org_cod"..
                      "      and projeto.proj_cod="..tab_projs.proj_cod)
               local tipo_curva = DBRow().tipo_curva
               local peso = tonumber(ativ_peso_rel_proj)/100
               local realizado = (ativ_perc_real or 0)/peso
               local planejado = planejadoCurvaS(tipo_curva,
                                                 ativ_dt_ini_prev,
                                                 ativ_dt_fim_prev,
                                                 hoje)
               write( '<TD>',formata_valor(realizado),'% (',formata_valor(planejado),'%)</TD>' )
               write( '<TD>',formata_valor(realizado*peso),'% (',formata_valor(planejado*peso),'%)</TD>' )
               write( '</TR>' )
               o = o + 1
            end
            write ( '</TABLE><TABLE border="0">' )
         else
            write ( '</TABLE><TABLE border="0">' )
            write ( '<TR><TD><B>Atividades: </B>no h atividades para este projeto.</TD></TR>\n' )
            write ( '</TABLE><TABLE border="0">' )
         end
      end
      if tab_info[k] == 'custo' then   
         -- Captura em uma tabela os valores do custo realizado               
         local consulta_real = "SELECT YEAR(dt_realizacao) AS ano_real, SUM(valor_real) AS custo_real FROM ".. 
                               "custo_realizado WHERE proj_cod = "..tab_projs.proj_cod.." GROUP BY "..
                               "YEAR(dt_realizacao) ORDER BY YEAR(dt_realizacao)"
         DBExec(consulta_real)
         local resultado_real = DBRow()                                        
         custo_real_ano = {}
         while resultado_real do
            custo_real_ano[resultado_real.ano_real] = resultado_real.custo_real
            resultado_real = DBRow()
         end  
         
         -- Captura os valores de custo previsto na tabela de custo
         local consulta = "SELECT custo_ano AS ano_prev, custo_prev_ano AS custo_prev FROM custo WHERE proj_cod = "..
                           tab_projs.proj_cod.." ORDER BY custo_ano"
         DBExec(consulta)
         local resultado_prev = DBRow()
         custo_prev_ano = {}
         while resultado_prev do  
            if resultado_prev then
               custo_prev_ano[resultado_prev.ano_prev] = resultado_prev.custo_prev
            else
               custo_prev_ano[resultado_prev.ano_prev] = '0.00'
            end 
            resultado_prev = DBRow() 
         end   

         -- Monta a tabela com os valores de custo
         local ano = _ANO_INI_PEGASO_                            
         write ( '</TABLE><TABLE border="0">' )
         write ( '<TR><TD colspan="3"><B>Custo: </B></TD></TR>' )
         write ( '<TR><TD><b>Ano &nbsp;&nbsp;&nbsp;</TD><TD align="right"><b>Custo Previsto</TD>' )
         write ( '<TD align="right"><b>&nbsp;&nbsp;&nbsp; Custo Realizado</TD></TR>' )        
         while ano <= _ANO_FIM_PEGASO_ do                                          
            write( '<TR>' )
            write( '<TD>',ano,'</TD>' ) 
            if not custo_prev_ano[ano] then
               custo_prev_ano[ano] = 0.00
            end   
            write( '<TD align="right">&nbsp;&nbsp;&nbsp;',ponto_centavo(formata_valor(custo_prev_ano[ano])),'</TD>\n' )
            if not custo_real_ano[ano] then
            	  custo_real_ano[ano] = '0.00'
            end	  
            write( '<TD align="right">&nbsp;&nbsp;&nbsp;',ponto_centavo(formata_valor(custo_real_ano[ano])),'</TD>\n' )               
            ano = ano + 1
         end
         write ( '</TABLE><TABLE border="0">')         
      end
      if tab_info[k] == 'real_fisica' then            
         local realizacao = Desempenho(tab_projs.proj_cod)
         local planejado = formata_valor(realizacao.planejado or 0)
         local realizado = formata_valor(realizacao.realizado or 0)
         write('<TR><TD><B>% Fsico Realizado:</B> ',realizado,'%</TD><TD>&nbsp;</TD>')
         write('<TD><B>% Fsico Esperado: </B>',planejado,'%</TD></TR>' )
         -- Reabre a conexo pois realizacaoFisica fecha. Veja comentrio acima.
         if ESTADO_BD ~= 'aberto' then
            AbreBD()
         end
      end
      if tab_info[k] == 'desempenho' then
         write ( '<TR><TD><B>Desempenho do Projeto: </B>',retornaDesempenho(tab_projs.proj_desempenho),'</TD></TR>\n' )       
      end
      k = k + 1	
   end 
   write ( '<TR><TD>&nbsp;</TD></TR>' )
   write('</table>')  
   
   if ESTADO_BD == 'aberto' then
      FechaBD()
   end
end

-- ----------------------------------------------------------------------------------------------------------
-- Nao eh usado em PROJETOS.LUA mas varios outros scripts a usam
-- Se o script que chama essa funo estiver no diretrio LUA, a varivel dir_img deve receber o valor '../' 
-- antes da chamada da funo. Se o script estiver no diretrio HTML nenhuma atribuio precisa ser feita
-- ----------------------------------------------------------------------------------------------------------
-- tam_tab eh opcional e indica o tamanho da tabela, caso esse valor nao seja passado ele eh calculado
-- ----------------------------------------------------------------------------------------------------------
function listaProjsporOrgao( tab_projs, tam_tab )
   local i
   if ( strfind(cgilua.script_vdir, '/lua') ) then
       reldir = '../'
   else
       reldir = './'
   end 
    
   -- ---------------------------------------------------------------------
   -- esse valor estah associado a funcao listaProjsporOrgao() e indica em  
   -- qual diretorio as imagens devem ser procuradas
   -- ---------------------------------------------------------------------
   if not( temConteudo(dir_img) ) then  
      dir_img = reldir  
   end   
      
   -- ------------------------------------------------------------------------------------
   -- LISTA PROJETO ORDENADOS POR ORGAO E UNIDADE MOSTRANDO OS CAMPOS PEDIDOS PELO USURIO
   -- ------------------------------------------------------------------------------------
   if tipo == 'relatorio' then                                  
      dofile ( reldir..'ot.lua')
      dofile ( reldir..'acessabd.lua')            
      dofile ( reldir .. 'lua/orgaos.lua' )
      dofile ( reldir .. 'lua/constantes.lua' ) 
      
      if ( ( type(tab_projs[1]) ~= 'table' ) or ( not ( tab_projs[1].proj_cod ) ) ) then
         write( 'Nenhum projeto satisfaz a consulta.' )
      else                                    
         if not(temConteudo(tam_tab)) then
            i = 1            
            while tab_projs[i] do
               i = i + 1
            end
            tam_tab = i - 1                       
         end
  
         write ( '<HR WIDTH="98%">\n' ) 
         write ( '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<FONT COLOR=green><I>Nmero de projetos (<b>',tam_tab,'</b>)</I></FONT>\n' )
         write ( '<TABLE BORDER=0><TR><TD WIDTH=12>&nbsp;</TD>\n')
         write ( '<TD>\n' )
         montaBolasLegendas(dir_img)  -- vem de CORES.LUA
         write ( '</TD>\n' )
         write ( '</TR></TABLE>\n' )
         write ( '<HR WIDTH = "98%">\n' )
         write ( '<TABLE BORDER = "0" WIDTH = "100%"><TR>\n' )
         i = 1
                  
         while ( tab_projs[i] ) do
            cor, etiqueta = CorFase(tab_projs[i].proj_cod, tab_projs[i].stat_cod, tab_projs[i].proj_desempenho)            
   		      if not cgi.cons_cod then
   		         cgi.cons_cod = ''
   		      end
            if not cgi.acao then
            	 cgi.acao = ''
            end
            cgi.tipo_servico = 'person'           
            write ( '<TD>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</TD>\n')
            
            -- ---------------------------------------------------------------------------------------
            -- Se o projeto estah em edicao, nao eh linkada a ETIQUETA ao cronograma     
            -- --------------------------------------------------------------------------------------- 
            if ( strfind( cor, _IMG_EDICAO_ ) ) then
               write ( '<TD valign = "top"><img src='..cor..' alt="'..etiqueta..'" align = "top" border = "0"></TD><TD width="90%"><A HREF="' .. reldir .. 'result_consulta.html?cod='.. tab_projs[i].proj_cod .. '&tipo_servico='..cgi.tipo_servico..'&cons_cod='..cgi.cons_cod..'&acao='..cgi.acao..'"> ' .. retornaNome(tab_projs[i].proj_cod) .. '</A></TD></TR>\n')
            else               
               write ( '<TD valign = "top"><A HREF="'..dirImg..'cronog/cron_proj.html?proj_cod='..tab_projs[i].proj_cod..'&pagina='..cgi.pagina..'&tipo_servico='..cgi.tipo_servico..'&cons_cod='..cgi.cons_cod..'&acao='..cgi.acao..'"><img src='..cor..' alt="'..etiqueta..'" align = "top" border = "0"></TD><TD width="90%"><A HREF="' .. reldir .. 'result_consulta.html?cod='.. tab_projs[i].proj_cod .. '&tipo_servico='..cgi.tipo_servico..'&cons_cod='..cgi.cons_cod..'&acao='..cgi.acao..'"> ' .. retornaNome(tab_projs[i].proj_cod) .. '</A></TD></TR>\n')
            end                                                                                                    
            
            if temConteudo(cgi.recebe_informacoes) then         
               dofile ( reldir..'lua/constantes.lua')                
               write ( '<TR><TD>&nbsp;</TD><TD>&nbsp;</TD><TD>\n' )            
               ordenaCampos(tab_projs[i]) 
               write ( '</TD></TR>' )                     
            end 
            
            write ( '<TR><TD colspan="3"><CENTER><HR WIDTH=98%></CENTER></TD></TR>\n')              
          
            i = i + 1
         end         
         write ( '</TR></TABLE>' )
      end
      
   else     -- se nao for RELATORIO, trata CONSULTA        
      dofile ( reldir .. 'lua/orgaos.lua' )
      
      if ( ( type(tab_projs[1]) ~= 'table' ) or ( not ( tab_projs[1].proj_cod ) ) ) then
         write( 'Nenhum projeto satisfaz a consulta.' )
      else                                    
         if not(temConteudo(tam_tab)) then
            i = 1            
            while tab_projs[i] do
               i = i + 1
            end
            tam_tab = i - 1                       
         end
         
         write ( '<HR WIDTH="98%">\n' )         
         write ( '<TABLE BORDER="0">' )
         write ( '<TR><TD WIDTH=12>&nbsp;</TD>\n') 
         write ( '<TD><p align="left">&nbsp;<FONT COLOR=green><I>Nmero de projetos (<b>',tam_tab,'</b>)</I></FONT></TD></TR>' )            
         write ( '<TD WIDTH=12>&nbsp;</TD><TD>\n' )
         montaBolasLegendas(dir_img)  -- vem de CORES.LUA
         write ( '</TD>\n' )
         write ( '</TR></TABLE>\n' )
         write( '<HR WIDTH="98%">\n' )
       
         write( '<TABLE BORDER="0" WIDTH="100%">\n' ) 
         write( '<TR><TD>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</TD>\n' )          
         write( '<TD><TABLE BORDER="0" WIDTH="100%">\n' )        

         i = 1                      
         while ( tab_projs[i] ) do
            if ( ( tab_projs[i].org_cod ) and ( tab_projs[i].org_cod ~= OrgAnt ) and 
               ( tab_projs[i].org_cod ~= '' )) then
               OrgAnt = tab_projs[i].org_cod
               StatAnt = ''
               write('<TR><TD COLSPAN=2>&nbsp;</TD></TR><TR><TD COLSPAN=2><STRONG>' .. retornaSiglaOrg( tab_projs[i].org_cod ) )
               write(' - ' .. retornaNomeOrg( tab_projs[i].org_cod ) .. '</STRONG></TD></TR>\n')
            end            
            if ( ( tab_projs[i].unid_cod ) and ( tab_projs[i].unid_cod ~= UniAnt ) and 
               ( tab_projs[i].unid_cod ~= '' ) ) then
               UniAnt = tab_projs[i].unid_cod
               StatAnt = ''
               write('<TR><TD COLSPAN=2>&nbsp;</TD></TR><TR><TD COLSPAN=2>&nbsp;&nbsp;' .. retornaSiglaUnid( tab_projs[i].unid_cod ) )
               write(' - ' .. retornaNomeUnid( tab_projs[i].unid_cod ) .. '</TD></TR>\n')
            end
            if ( ( tab_projs[i].stat_cod ) and ( tab_projs[i].stat_cod ~= StatAnt ) and 
               ( tab_projs[i].stat_cod ~= '' ) ) then
               StatAnt = tab_projs[i].stat_cod
               write('<TR><TD COLSPAN=2>&nbsp;</TD></TR><TR><TD COLSPAN=2><I><B>&nbsp;&nbsp;&nbsp;&nbsp;' .. retornaDescrStat( tab_projs[i].stat_cod ).. '</B></I></TD></TR>\n')
            end
            
            cor, etiqueta = CorFase(tab_projs[i].proj_cod, tab_projs[i].stat_cod, tab_projs[i].proj_desempenho)
   		      if not cgi.cons_cod then
   		   	     cgi.cons_cod = ''
   		      end
            if not cgi.acao then
            	 cgi.acao = ''
            end
            
            -- ---------------------------------------------------------------------------------------
            -- Se o projeto estah em edicao, nao eh linkada a ETIQUETA ao cronograma     
            -- --------------------------------------------------------------------------------------- 
            if strfind( cor, _IMG_EDICAO_ ) then                     
               write( '<TR><TD valign = "top">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<img src='..cor..' alt="'..etiqueta..'" align = "top" border = "0"></TD><TD width="93%"><A HREF="' .. reldir .. 'result_consulta.html?cod='.. tab_projs[i].proj_cod .. '&tipo_servico='..cgi.tipo_servico..'&cons_cod='..cgi.cons_cod..'&acao='..cgi.acao..'">' .. retornaNome(tab_projs[i].proj_cod) .. '</A></TD></TR>\n')
            else
               write( '<TR><TD valign = "top">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<A HREF="'..dirImg..'cronog/cron_proj.html?proj_cod='..tab_projs[i].proj_cod..'&pagina='..cgi.pagina..'&tipo_servico='..cgi.tipo_servico..'&cons_cod='..cgi.cons_cod..'&acao='..cgi.acao..'"><img src='..cor..' alt="'..etiqueta..'" align = "top" border = "0"></TD><TD width="93%"><A HREF="' .. reldir .. 'result_consulta.html?cod='.. tab_projs[i].proj_cod .. '&tipo_servico='..cgi.tipo_servico..'&cons_cod='..cgi.cons_cod..'&acao='..cgi.acao..'">' .. retornaNome(tab_projs[i].proj_cod) .. '</A></TD></TR>\n')         
            end
            i = i + 1
         end
         write( '</TD></TR></TABLE>\n' )
         write( '</TABLE>\n' )
      end      
   end    
end

-- Nao eh utilizada em PROJETOS.LUA mas os outros scripts que chamam a PROJETOS.LUA a usam
function listaFollowUp( cod, limite, titulo )  
   if ( strfind(cgilua.script_vdir, '/lua') ) then
       reldir = '../'
   else
       reldir = './'
   end
   
   dofile( reldir..'acessabd.lua' )
   
   if ESTADO_BD ~= 'aberto' then
      AbreBD()
   end
   
   query = "SELECT fup_resp as resp, fup_data as data, fup_verificacao as verif, fup_descr as descr "..
           "FROM follow_up WHERE fup_proj_cod = " .. cod .. " ORDER BY fup_data DESC, fup_cod DESC "     
   DBExec( query )
   fup = DBRow()
   
   if fup then          	 
      write( '<TABLE WIDTH="80%" BORDER="0" ALIGN="CENTER">\n')
      if titulo then
         write( '<TR>\n' )
         write( '<TD COLSPAN=4 ALIGN=CENTER class=fieldLabel><B>'..titulo..'</B></TD>\n')
         write( '</TR>\n' )
         write( '<TR><TD COLSPAN=4>&nbsp;</TD></TR>\n' )         
      end   
      write( '<TR>\n' )
      write( '<TD><B>Responsvel</B></TD>\n' )   
      write( '<TD><B>Data de Incluso</B></TD>\n' )
      write( '<TD><B>Verificao do Projeto</B></TD>\n' )
      write( '<TD><B>Descrio</B></TD>\n' )
      write( '</TR>\n' )     
      tab = {} 
      cont = 1      
      sem_limite = 0
      if limite == 0 then
      	 limite = cont + 1
      	 sem_limite = 1
      end 	 
      while fup and cont <= limite do
      	    tab[cont] = {}
      	    tab[cont].resp = fup.resp
            tab[cont].data = formataData2(fup.data)
            if fup.verif == 1 then 
               tab[cont].verif = 'Ok'
            else   
               tab[cont].verif = 'No Ok'
            end   
            tab[cont].descr = fup.descr            
            fup  = DBRow()
            cont = cont + 1            
            if sem_limite == 1 then
               limite = limite + 1
            end   
      end                          
      cor = "#CCCCCC"
      cont = cont - 1         
      while tab[cont] and cont > 0 do
      	    cor = AlternaCorLinha(cor)                      
      	    write( '<TR BGCOLOR=',cor,'>\n' )
      	    write( '<TD>'..tab[cont].resp..'</TD>\n' )   
            write( '<TD>'..tab[cont].data..'</TD>\n' )
            write( '<TD>'..tab[cont].verif..'</TD>\n' )              
            write( '<TD>'..tab[cont].descr..'</TD>\n' )
            write( '</TR>\n' )           
            cont = cont - 1
      end       
      write( '</TABLE>\n')
      write( '<BR><HR WIDTH="98%"><BR>' )   
  else  
    write( '<TABLE WIDTH="80%" BORDER="0" ALIGN="CENTER">\n')    
       write( '<TR>\n' )
         write( '<TD ALIGN=CENTER class=fieldLabel><B>No h registro de Follow-Up para esse projeto!</B></TD>\n')
       write( '</TR>\n')
    write( '</TABLE>\n')
    write( '<BR><HR WIDTH="98%"><BR>' ) 
  end             
      
  if ESTADO_BD == 'aberto' then
     FechaBD()
  end
   
end