-- -------------------------------------------------------------------------------------------
-- ATIVIDADES.LUA
-- -------------------------------------------------------------------------------------------
   dofile( "global.lua" )   

-- -------------------------------------------------------------------------------------------
-- Verifica se foi digitada alguma data em formato invlido ( ~= DD/MM/AAAA )
-- Utiliza a varivel ERRO_DATA para fazer o controle
-- Se um dos formatos for invlido, no faz as verificaes dos campos de data
-- -------------------------------------------------------------------------------------------  
   dt_ini        = tonumber(inclui_data(cgi.dt_ini_prevista_ativ))
   dt_fim        = tonumber(inclui_data(cgi.dt_fim_prevista_ativ))
   cgi.erro_data = 'no'
   
-- --------------------------------------------------------------------------------------------
-- Eh inicializada com zero indicando que nenhuma alteracao foi efetuada, seu valor passa para 
-- '1' quando a atividade eh alterada.
-- Dessa forma se faz o controle da atualizacao da tabela de FOLLOW-UP ( se o flag for 1 
-- indica que a atividade foi ALTERADA, se for 0 indica que ou ocorreu algum erro ou que uma
-- nova atividade foi inserida.
-- --------------------------------------------------------------------------------------------   
   flag_update   = 0
   
   if type(dt_ini) ~= 'number' or type(dt_fim) ~= 'number'then
   	cgi.erro_data = 'yes'
   end 	

-- ---------------------------------------------------------------------------------------------
-- Funes internas para validao do formulrio de atividades
-- [ limpaCampos() e verifica_peso() ]
-- ---------------------------------------------------------------------------------------------
   function limpaCampos()
        cgi.descricao_ativ       = nil
        cgi.dt_ini_prevista_ativ = nil
        cgi.dt_fim_prevista_ativ = nil
        cgi.alerta               = nil
        cgi.peso                 = nil   
        cgi.ativ_cod             = nil
        cgi.areas                = nil
        cgi.dep_descr            = nil
        cgi.ativ_default         = nil
   end   

   function verifica_peso()      
        sql1 = "SELECT SUM(ativ_peso_rel_proj) as valor FROM atividade WHERE proj_cod = "..cgi.proj_cod
        DBExec(sql1)
        tmp = DBRow()
        if tmp.valor ~= null then
           tmp = tmp.valor + tonumber(cgi.peso)
        else
           tmp = tonumber(cgi.peso)        
        end
        
        -- ---------------------------------------------------------------------------------------------
        -- Verifica se o somatrio dos pesos no  maior que 100
        -- ---------------------------------------------------------------------------------------------
        if cgi.peso_antigo then
           tmp = tmp - tonumber(cgi.peso_antigo)
        end
        if tmp > 100 then
           msg_temp = 'O somatrio dos pesos das atividades no pode ser maior que 100.'	
        else
           msg_temp = nil
        end
        return msg_temp   
   end
   
-- ----------------------------------------------------------------------------------------------
-- Verifica qual opo foi selecionada no arquivo de edio de atividades
-- [ 'Grava' ou 'Limpa Campos' ]
-- ----------------------------------------------------------------------------------------------   
if cgi.botao == 'Limpa' then
   limpaCampos()
   
-- ---------------------------------------------------------------------------------------------
-- VOLTA PARA A PGINA html carregando os valores de proj_ccod, tipo_servio e tipo_edi
-- ---------------------------------------------------------------------------------------------    
   cgilua.redirect('../atividades.html?proj_cod='..cgi.proj_cod..'&tipo_servico='..cgi.tipo_servico..'&tipo_edi='..cgi.tipo_edi)

elseif cgi.botao == 'Grava' then
  -- ---------------------------------------------------------------------------------------------	
  -- CARREGA A BIBLIOTECA VALIDAFORM 
  -- ---------------------------------------------------------------------------------------------
     dofile("../validaform/validaform.lua")
     dofile("form_atividades.lua")   
     dofile( "acessabd.lua" ) 
   
     if ESTADO_BD ~= 'aberto' then
        AbreBD()
     end

  -- ---------------------------------------------------------------------------------------------	
  -- ---------------------------------------------------------------------------------------------	
  -- Faz a validao do formulrio com o FORM_ATIVIDADES.LUA
  -- ---------------------------------------------------------------------------------------------
  -- ---------------------------------------------------------------------------------------------	
     cgi.msg = form_atividades:critica()   
 
  -- ---------------------------------------------------------------------------------------------	
  -- ---------------------------------------------------------------------------------------------	
  -- Faz a validao do formulrio com o prprio ATIVIDADES.LUA
  -- ---------------------------------------------------------------------------------------------
  -- ---------------------------------------------------------------------------------------------	
          
  -- ---------------------------------------------------------------------------------------------
  -- S verifica o PESO se o campo foi preenchido
  -- ---------------------------------------------------------------------------------------------
     if cgi.peso and cgi.peso ~= '' and not cgi.msg then
        cgi.msg_tmp = verifica_peso()
     end   
  
  -- ---------------------------------------------------------------------------------------------
  -- S verifica as datas se os dois campos foram preenchidos no formato DD/MM/AAAA
  -- ---------------------------------------------------------------------------------------------
     if cgi.erro_data == 'no' then          
        data1 = strsub(cgi.dt_ini_prevista_ativ,7)..strsub(cgi.dt_ini_prevista_ativ,4,5)..strsub(cgi.dt_ini_prevista_ativ,1,2)
        data2 = strsub(cgi.dt_fim_prevista_ativ,7)..strsub(cgi.dt_fim_prevista_ativ,4,5)..strsub(cgi.dt_fim_prevista_ativ,1,2)
      
        if ( data1 == data2 ) then
            cgi.msg_datas_iguais = 'As datas de incio e fim previstas no podem ser iguais.'
            -- ---------------------------------------------------------------------------------------------
            -- Provisoriamente no est sendo verificado
            -- ---------------------------------------------------------------------------------------------
            -- VOLTA PARA A PGINA html
            -- ---------------------------------------------------------------------------------------------
            -- if ESTADO_BD == 'aberto' then
            --    FechaBD()
            -- end
            -- cgilua.redirect('../atividades.html?'..cgilua.encodecgi())
            -- ---------------------------------------------------------------------------------------------
            -- Evita que o restante do cdigo seja executado
            -- ---------------------------------------------------------------------------------------------
            -- exit()
        end
             
        sql_result = "select proj_dt_ini_prev, proj_dt_fim_prev from projeto where proj_cod = "..tonumber(cgi.proj_cod)..""
        DBExec(sql_result)
        result = DBRow()        
     
        data3 = inclui_data(result.proj_dt_ini_prev)
        data4 = inclui_data(result.proj_dt_fim_prev)
         
        if (tonumber (data1) < tonumber(data3) or tonumber(data1) > tonumber(data4)) 
            or (tonumber(data2) < tonumber(data3) or tonumber(data2) > tonumber(data4)) then 
            cgi.msg_data = 'As Datas Previstas para Atividade devem estar entre '..formataData(result.proj_dt_ini_prev)..' e '..formataData(result.proj_dt_fim_prev)..'.'  
        elseif tonumber(data1) > tonumber(data2) then
            cgi.msg_data = 'A Data de Incio Previsto no pode ser maior que a Data de Fim Previsto.'
        end    
     end -- if cgi.erro_data == 'no' then  
     
     -- ---------------------------------------------------------------------------------------------		      
     -- Verifica se  atualizao
     -- ---------------------------------------------------------------------------------------------	
     if cgi.ativ_cod then 
   	    cgi.descricao_ativ = forca_plic(cgi.descricao_ativ)        
        sql_verifica = "select ativ_cod from atividade where ativ_nome = '"..cgi.descricao_ativ.."' AND proj_cod = "..tonumber(cgi.proj_cod)..""
        DBExec(sql_verifica)
        verifica = DBRow()
        -- ---------------------------------------------------------------------------------------------	
        -- Verifica se o nome da atividade foi alterado
        -- ---------------------------------------------------------------------------------------------	
        if verifica then
           -- ---------------------------------------------------------------------------------------------	
           -- Verifica se o novo nome existe para outra atividade
           -- ---------------------------------------------------------------------------------------------	
           if verifica.ativ_cod ~= tonumber(cgi.ativ_cod) then
       	      cgi.msg_verifica     ="Esta atividade j existe"  
       	      cgi.msg_verificadesc ="Fornea uma descrio que ainda no tenha sido cadastrada"
           else
              cgi.descricao_ativ = forca_plic(cgi.descricao_ativ)
              -- ---------------------------------------------------------------------------------------------	
              -- S faz a atualizao no banco de dados se no houver problemas com os formatos das datas
              -- ---------------------------------------------------------------------------------------------	
              if cgi.erro_data == 'no' then
                 sql = "UPDATE atividade SET proj_cod="..cgi.proj_cod..",ativ_nome='"..cgi.descricao_ativ.."', ativ_dt_ini_prev='"..data1.."', ativ_dt_fim_prev='"..data2.."',ativ_peso_rel_proj='"..cgi.peso.."',ativ_alerta='"..cgi.alerta.."' where ativ_cod = "..cgi.ativ_cod
                 flag_update = 1
                 --mensagem = "A atividade <b>"..cgi.descricao_ativ.."</b> foi atualizada." 
              end   
           end              
        else
           cgi.descricao_ativ = forca_plic(cgi.descricao_ativ)           
           sql = "UPDATE atividade SET proj_cod="..cgi.proj_cod..",ativ_nome='"..cgi.descricao_ativ.."', ativ_dt_ini_prev='"..data1.."', ativ_dt_fim_prev='"..data2.."',ativ_peso_rel_proj="..cgi.peso..",ativ_alerta="..cgi.alerta.." where ativ_cod = "..cgi.ativ_cod
           flag_update = 1
           --mensagem = "A atividade <b>"..cgi.descricao_ativ.."</b> foi atualizada." 
        end
        
     else  -- No  atualizao
        -- ---------------------------------------------------------------------------------------------	
        -- Verifica se a atividade j existe
        -- ---------------------------------------------------------------------------------------------	
        sql_verifica = "select * from atividade where ativ_nome = '"..cgi.descricao_ativ.."' AND proj_cod = "..tonumber(cgi.proj_cod)..""
        DBExec(sql_verifica)
        verifica = DBRow()
        if verifica and verifica.ativ_nome then
           cgi.msg_verifica      ="Esta atividade j existe"
           cgi.msg_verifica_desc ="Fornea uma descrio que ainda no tenha sido cadastrada"
        else
           cgi.descricao_ativ = forca_plic(cgi.descricao_ativ)           	   
           -- ---------------------------------------------------------------------------------------------	
           -- S faz a atualizao no banco de dados se no houver problemas com os formatos das datas
           -- ---------------------------------------------------------------------------------------------	
           if cgi.erro_data == 'no' then        
              sql  = "INSERT INTO atividade (proj_cod,ativ_nome, ativ_dt_ini_prev, ativ_dt_fim_prev,ativ_peso_rel_proj,ativ_alerta) "..
                     "values ("..cgi.proj_cod..",'"..cgi.descricao_ativ.."','"..data1.."','"..data2.."','"..cgi.peso.."','"..cgi.alerta.."')"
                
           end   
        end    
     end 
     
  if cgi.msg or cgi.msg_verifica or cgi.msg_tmp or cgi.msg_data then
     cgi.voltou = 1     
     -- ---------------------------------------------------------------------------------------------
     -- VOLTA PARA A PGINA html
     -- ---------------------------------------------------------------------------------------------
     if ESTADO_BD == 'aberto' then
        FechaBD()
     end
     cgilua.redirect('../atividades.html?'..cgilua.encodecgi())   
       
     -- ---------------------------------------------------------------------------------------------
     -- Evita que o restante do cdigo seja executado
     -- ---------------------------------------------------------------------------------------------
     exit()
  end         	
  if sql then
     DBExec(sql)
     -- ---------------------------------------------------------------------------------------------
     -- Mantm a consistncia do campo proj_soma_ativ da tabela projeto
     -- ---------------------------------------------------------------------------------------------        
     DBExec([[UPDATE projeto
              SET projeto.proj_soma_ativ = (select sum(atividade.ativ_peso_rel_proj) from atividade 
                                            where atividade.proj_cod = ]]..cgi.proj_cod..[[)
              FROM projeto, atividade
              WHERE projeto.proj_cod = ]]..cgi.proj_cod)
     
     -- ---------------------------------------------------------------------------------------         
     -- Atualizao do campo PROJ_DESEMPENHO na tabela PROJETO quando so gravadas alteraes
     -- no projeto pela funo de CADASTRO/EDICAO DE ATIVIDADES
     -- ---------------------------------------------------------------------------------------                                                  
        atualizaProjDesempenho(cgi.proj_cod)  
             
     -- ---------------------------------------------------------------------------------------------
     -- Se a atividade acabou de ser criada (flag_update == 0) recupera o valor de ativ_cod
     -- ---------------------------------------------------------------------------------------------        
     if flag_update == 0 then
     	ativ_query = " SELECT ativ_cod AS cod FROM atividade WHERE proj_cod = "..cgi.proj_cod.." AND ativ_nome = '"..cgi.descricao_ativ.."'"
     	DBExec(ativ_query)
     	ativ_cod = DBRow()
     	ativ_cod = ativ_cod.cod    
     end 	
          
     -- INSERO DE UMA DEPENDNCIA
     if not cgi.dep_descr then
        cgi.dep_descr = ''
     else
        cgi.dep_descr = forca_plic(cgi.dep_descr)   
     end    

     -- ---------------------------------------------------------------------------------------                                       
     -- SE FOR ATUALIZAO DE DADOS NA ATIVIDADE, NO INSERE NADA NA TABELA DE DEPENDENCIA
     -- ---------------------------------------------------------------------------------------                                           
     -- Insere dependencia pela primeira vez
     -- ---------------------------------------------------------------------------------------                                           
        if ativ_cod and cgi.areas and cgi.areas ~= '' then
           campos  = "dep_proj_cod, dep_ativ_cod, dep_area_cod, dep_descr"
           valores =  cgi.proj_cod..", "..ativ_cod..", "..cgi.areas                 
           if cgi.dep_descr ~= '' then 	              
              valores = valores..", '"..cgi.dep_descr.."'"
           else
              valores = valores..", ''"                          
           end
           inclusao_dependencia = "INSERT INTO dependencia ("..campos..") VALUES ("..valores..")"                                                               
           DBExec(inclusao_dependencia)
               
      -- ---------------------------------------------------------------------------------------                                           
      -- Altera dependencia jah cadastrada
      -- ---------------------------------------------------------------------------------------                                           
        elseif cgi.ativ_cod then           
           local select = "SELECT dep_cod FROM dependencia WHERE dep_ativ_cod = " .. tonumber(cgi.ativ_cod)
           DBExec(select)
           local resultado = DBRow()
           if resultado and resultado.dep_cod then
              if not cgi.areas or cgi.areas == '' then
                 local delete = "DELETE FROM dependencia WHERE dep_cod = " .. tonumber(resultado.dep_cod)           	
                 DBExec(delete)
              else
                 if cgi.dep_descr ~= '' then  	
                    alteracao_dependencia = "UPDATE dependencia SET dep_area_cod = "..cgi.areas..", dep_descr = '"..cgi.dep_descr.."' WHERE dep_ativ_cod = "..cgi.ativ_cod..""        
                 else
                    alteracao_dependencia = "UPDATE dependencia SET dep_area_cod = "..cgi.areas..", dep_descr = '' WHERE dep_ativ_cod = "..cgi.ativ_cod..""        
                 end
                 DBExec(alteracao_dependencia)     
              end
           elseif cgi.areas and cgi.areas ~= '' then
              campos  = "dep_proj_cod, dep_ativ_cod, dep_area_cod, dep_descr"
              valores =  cgi.proj_cod..", "..cgi.ativ_cod..", "..cgi.areas                 
              if cgi.dep_descr ~= '' then 	              
                 valores = valores..", '"..cgi.dep_descr.."'"
              else
                 valores = valores..", ''"                          
              end
              inclusao_dependencia = "INSERT INTO dependencia ("..campos..") VALUES ("..valores..")"                                                               
              DBExec(inclusao_dependencia)
           end
               
        end
        limpaCampos()      
  end
    
  if ESTADO_BD == 'aberto' then
     FechaBD()
  end
  cgilua.redirect ('../atividades.html?'..cgilua.encodecgi())
else
  -- Evita que os valores que venham apos plics na string sejam omitidos na pagina HTML
  cgi.descricao_ativ = forca_plic(cgi.descricao_ativ)
  if ESTADO_BD == 'aberto' then
     FechaBD()
  end
  cgilua.redirect ('../atividades.html?'..cgilua.encodecgi())        
end 
