-- ------------------------------------------------------------------------------
-- CUSTO_PREVISTO
-- ------------------------------------------------------------------------------
-- Responsavel pelas operacoes de cadastramento e edicao de custo previsto de um
-- projeto
-- ------------------------------------------------------------------------------
-- $Revision: $
-- $Date: $ $NoKeywords: $
--
-- Copyright by TecGraf (PUC-RIO)
-- ------------------------------------------------------------------------------
   assert( dofile ( "form_custo_previsto.lua" ) )
   assert( dofile ( "global.lua" ) )
   assert( dofile ( "acessabd.lua" ) )      

-- ------------------------------------------------------------------------------  
   function dias_em_fevereiro (ano)  
      -- ------------------------------------------------------------------------
      -- Fevereiro tem 29 dias nos anos divisiveis por quatro,
      -- EXCETO para os anos centuriais que tambem nao sao divisiveis por 400
      -- ------------------------------------------------------------------------
      if strlen(ano) == 1 then
         ano = '200'..ano
      end
         
      ano = tonumber(ano)
      
      if (mod(ano, 4) == 0) and ( (not (mod(ano, 100) == 0)) or (mod(ano, 400) == 0) ) then
         return ( 29 )
      else
         return ( 28 )
      end   
   end
-- ------------------------------------------------------------------------------
  
   i     = tonumber(cgi.ult_dig_ano_ini) 
   meses = {'jan','fev','mar','abr','mai','jun','jul','ago','set','out','nov','dez', 'som_ano'}            
   
   -- -------------------------------------------------------------------------------------------------------
   -- O numero de dias do mes 02 (fevereiro) eh alterado em funcao do ano pela funcao dias_em_fevereiro()
   -- -------------------------------------------------------------------------------------------------------
   dias  = {31, 29, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31}

   -- -------------------------------------------------------------------------------------------------------
   -- Se algum registro for alterado em CUSTO_PREVISTO assume o valor '1'
   -- -------------------------------------------------------------------------------------------------------
   cgi.msgsuc = 0
   
   -- -------------------------------------------------------------------------------------------------------
   -- Se algum registro for alterado em CUSTO assume o valor '0', caso acuse alguma duplicacao, assume o 
   -- valor '1' e passa a depender do valor de CGI.ALERTA
   -- -------------------------------------------------------------------------------------------------------
   cgi.msg_custo_anual = 2   	  
   cgi.msg_anual       = 2
   
   -- -------------------------------------------------------------------------------------------------------
   -- Verifica preenchimento do formulario atraves do VALIDAFORM
   -- -------------------------------------------------------------------------------------------------------
   cgi.msg = form_custo_previsto:critica()      
      
   if not( temConteudo(cgi.msg) ) then   

      if ESTADO_BD ~= 'aberto' then
         AbreBD()
      end
      
      custo_total = 0 

      -- --------------------------------------------------------------------------------------
      -- 'i' corresponde ao ltimo dgito de ano (EX: 2001 -> i = 1) 
      -- --------------------------------------------------------------------------------------
      while i <= tonumber(cgi.ult_dig_ano_fim) do  

      	dias[2] = dias_em_fevereiro(i)
      	  	
         j         = 13
         limite    = 1	
      	
         if i == tonumber(cgi.ult_dig_ano_ini) then
            limite = tonumber(cgi.mes_ini)
         elseif i == tonumber(cgi.ult_dig_ano_fim) then
            j       = tonumber(cgi.mes_fim) + 1   
            compara = tonumber(cgi.mes_fim) + 1    	
         end                

         -- --------------------------------------------------------------------------------------
         -- 'j' corresponde aos meses (EX: Janeiro -> j = 1) e 'limite' corresponde a 1
         -- 'j'  inicializado com 13 se 'i' corresponde ao ano inicial ou aos anos intermediarios
         -- e com cgi.mes_fim + 1 se 'i' corresponde ao ultimo ano (lembrando que ano inicial e 
         -- o ultimo ano podem ser os mesmos, nesse caso, vale para 'j' a regra para o ultimo ano
         -- --------------------------------------------------------------------------------------                 
         while j >= limite do 
         	      	
           if (j == 13) or (i == tonumber(cgi.ult_dig_ano_fim) and j == compara) then           
               old_mes  = meses[j] 	
               meses[j] = 'som_ano'  	           
               ano = "200"..i
               
               -- --------------------------------------------------------------------------------------------
               -- Permite que seja inserido zeros na tabela de CUSTO, mas nesse caso, nenhuma entrada eh 
               -- cadastrada em CUSTO_PREVISTO, evitando que entradas nulas sejam inseridas na base o que
               -- provocaria um "inchamento" na base 
               -- --------------------------------------------------------------------------------------------
               valor = dostring('return cgi.custo_prev_'..meses[j]..i)                
               if not valor or valor == '' or valor == ' ' then
               	valor = 0
               	cgi['custo_prev_'..meses[j]..i] = '0,00'
               end 	
                                                            
               if tonumber(valor) == 0 then                           
                  valor = '0,00'
               end 
                
               if (strsub(valor,1,1) ~= '-') then                                    
                  if (valor) and strfind(valor,'%D') then
                     valor = gsub( valor, "%D", "." )                  
                  end  
                        
                  if valor and valor ~= '' and valor ~= ' ' then
                     valor = format("%.2f", valor)
                  end   
               end    
                          
               -- --------------------------------------------------------------------------------------------------------
               -- TRATAMENTO DE CUSTO (custo previsto anual)
               -- --------------------------------------------------------------------------------------------------------                                                   	                                        
               
               -- --------------------------------------------------------------------------------------------------------
               -- Seleciona a entrada do custo previsto anual para o projeto em questao naquele ANO
               -- --------------------------------------------------------------------------------------------------------
               sql_repetido = " SELECT custo_cod, custo_prev_ano  FROM custo WHERE proj_cod = "..cgi.proj_cod..
                              " AND custo_ano = "..ano.." ORDER BY custo_cod DESC"
               DBExec(sql_repetido)
               repetido = DBRow() 
               
               if tonumber(cgi['custo_previsto_'..ano]) == tonumber(valor) then 
               	flag_repetido = 1
               end 	               	
                              
               -- --------------------------------------------------------------------------------------------------------
               -- Depois de verificar se os valores em CGI e VALOR so iguais, passa pro CGI o valor correspondente a 
               -- custo anual previsto calculado em VALOR
               -- --------------------------------------------------------------------------------------------------------
               cgi['custo_previsto_'..ano] = gsub(valor,',','.') 

               -- --------------------------------------------------------------------------------------------------------
               -- Faz em custo_total um somatorio com todos os valores de custo previsto anual
               -- --------------------------------------------------------------------------------------------------------               
               custo_total = custo_total + tonumber(cgi['custo_previsto_'..ano])

               -- --------------------------------------------------------------------------------------------------------
               -- Faz comparacoes com VALOR (caso exista e seja um valor valido) e com CGI (flag_repetido) para efetuar as
               -- ATUALIZACOES no banco de dados.
               -- --------------------------------------------------------------------------------------------------------                                		            	
               if (repetido) and (valor and valor ~= '' and valor ~= ' ') then                  		            	
                  if repetido.custo_prev_ano then               	  
                     repetido.custo_prev_ano = format("%.2f",repetido.custo_prev_ano)                                            	
                     if (tostring(repetido.custo_prev_ano) ~= tostring(valor)) then                      	
                        if repetido.custo_prev_ano == '0.00' then
                           cgi.alerta = 1
                        else 
                           cgi.msg_custo_anual = 1 	
                        end	                                           	
                        if tonumber(cgi.alerta) == 1 or flag_repetido == 1 then                               
                           sql_custo_anual = " UPDATE custo SET custo_prev_ano="..valor.." WHERE proj_cod = "..cgi.proj_cod..
                                             " AND custo_ano = "..ano.." AND custo_cod = "..repetido.custo_cod                                                                                                                                                                                                                                                      
                           DBExec(sql_custo_anual)                                                       
                           cgi.msg_custo_anual = 0
                           if tonumber(cgi.msg_anual) == 1 then
                              cgi.msg_anual = 0
                           end
                        end                          
                     else -- o valor de custo no banco e o valor a ser inserido sao iguais
                        cgi.msg_custo_anual = 2                                                                             
                     end    
                  end                                    
               end 
               meses[j] = old_mes 
               if ( tonumber(cgi.msg_anual) ~= 1 and tonumber(cgi.msg_anual) ~= 0) then                	  
                  cgi.msg_anual = cgi.msg_custo_anual                  
               end                                          
           else   
              -- --------------------------------------------------------------------------------------------------------
              -- TRATAMENTO DE CUSTO_PREVISTO (custo previsto mensal)
              -- --------------------------------------------------------------------------------------------------------                                                   	                                        
              if tonumber(cgi.msg_custo_anual) ~= 1 then
              	
              	  -- --------------------------------------------------------------------------------------------
              	  -- Monta a data a ser inserida na tabela de CUSTO_PREVISTO...
              	  -- Por DEFAULT, os dias sao inseridos no banco correspondendo ao ultimo dia do mes (ver vetor
              	  -- dias[]
              	  -- Se estamos no ano final e mes final, entao a data deve ser tratada, ou seja, o dia tem que
              	  -- corresponder ao dia que foi fornecido na data prevista de fim de projeto (cgi.dia_fim) 
              	  -- --------------------------------------------------------------------------------------------               	
              	  if ( i == tonumber(cgi.ult_dig_ano_fim) ) and ( j == tonumber(cgi.mes_fim) ) and ( tonumber(cgi.dia_fim) < dias[j] ) then   
                    dias[j] = cgi.dia_fim                                        
                 end   
                 if strlen(j) == 1 then	
                    data = "200"..i.."0"..j..dias[j]
                 elseif strlen(j) == 2 then
                    data = "200"..i..j..dias[j]
                 end        	            
                 valor = dostring('return cgi.custo_prev_'..meses[j]..i)                  
                                 
                 if tonumber(valor) == 0 then                           
                    valor = '0,00'
                 end   
                 
                 if (strsub(valor,1,1) ~= '-') then
                    if valor and strfind(valor,'%D') then                 	 
                       valor = gsub( valor, "%D", "." )                      
                    end  
                    
                    if valor and valor ~= '' and valor ~= ' ' then
                       valor = format("%.2f", valor)
                    end   
                 end                 
                 
                 -- --------------------------------------------------------------------------------------------------------
                 -- Verifica se as entradas do custo previsto mensal nao sao repetidas para um mesmo ano e mesmo mes
                 -- --------------------------------------------------------------------------------------------------------                                                   	                 
                 sql_repetido = "SELECT * FROM custo_previsto WHERE proj_cod = "..cgi.proj_cod.." AND year(dt_prevista) = 200"..i.." AND month(dt_prevista)= "..j           	
                 DBExec(sql_repetido)           
                 repetido_mes = DBRow() 
                 
                 -- --------------------------------------------------------------------------------------------------------
                 -- Atualiza a base de dados alterando a data cadastrada se alguma alteracao ocorreu na data cadastrada do 
                 -- projeto
                 -- Por exemplo: A data de fim previsto para o projeto era 15/06/2001 e foi alterada para 15/06/2002
                 -- Nesse caso, o valor cadastrado para 15/06/2001 tem que ter a sua data alterada para 30/06/2001
                 -- --------------------------------------------------------------------------------------------------------                                                   	                                                                     	
                 if ( repetido_mes and repetido_mes.dt_prevista ) then   
                 	  if inclui_data(repetido_mes.dt_prevista) ~= data then
                       sql_update = "UPDATE custo_previsto SET dt_prevista = '"..data.."' WHERE proj_cod = "..cgi.proj_cod.." AND year(dt_prevista) = 200"..i.." AND month(dt_prevista)= "..j          	                    
                       DBExec(sql_update) 
                       cgi.msgsuc = 1                                                                                  
                    end
                 end                 
                 
                 -- --------------------------------------------------------------------------------------------------------
                 -- Verifica se as entradas do custo previsto mensal de um projeto jah estao cadastradas para uma data 
                 -- especifica
                 -- --------------------------------------------------------------------------------------------------------                                                   	                                    
                 sql_repetido = "SELECT * FROM custo_previsto WHERE proj_cod = "..cgi.proj_cod.." AND dt_prevista = '"..data.."'"           	
                 DBExec(sql_repetido)           
                 repetido = DBRow() 
                 
                 -- --------------------------------------------------------------------------------------------------------
                 -- Se nao ha nenhum valor cadastrado para o projeto nessa data e a entrada do usuario corresponde a um 
                 -- valor valido, uma INSERCAO eh feita na base de dados
                 -- --------------------------------------------------------------------------------------------------------                                                   	                                                                     
                 if (not repetido) and (valor and valor ~= '' and valor ~= ' ') then                                         
                    sql_custo_mensal = "INSERT INTO custo_previsto (proj_cod,dt_prevista,valor_real) VALUES ("..cgi.proj_cod..",'"..data.."',"..valor..")"           
                    DBExec(sql_custo_mensal)                    
                    cgi.msgsuc = 1
                 elseif ( repetido and (valor and valor ~= '' and valor ~= ' ') ) then
                    if repetido.valor_real then
                       repetido.valor_real = format("%.2f",repetido.valor_real)
                       if repetido_mes and repetido_mes.valor_real then
                          repetido_mes.valor_real = format("%.2f",repetido_mes.valor_real)
                          if ( tostring(repetido_mes.valor_real) ~= tostring(valor) ) then
                          	  flag_repetido_mes = 1
                          end
                       end 
                 
                       -- --------------------------------------------------------------------------------------------------------
                       -- Se jah existe um valor cadastrado para o projeto nessa data no banco de dados mas a entrada do usuario
                       -- corresponde a um valor valido diferente do cadastrado, uma ATUALIZACAO eh feita na base de dados
                       -- --------------------------------------------------------------------------------------------------------                                                   	                                                                                                	  
                       if ( tostring(repetido.valor_real) ~= tostring(valor) ) or flag_repetido_mes == 1  then                       	
                          sql_custo_mensal = "UPDATE custo_previsto SET valor_real="..valor.." WHERE proj_cod = "..cgi.proj_cod.." AND dt_prevista = '"..data.."'"                       
                          DBExec(sql_custo_mensal)
                          cgi.msgsuc = 1
                       end   
                    end  
                 end
                 
                 -- --------------------------------------------------------------------------------------------------------
                 -- Se jah existe um valor cadastrado para o projeto nessa data no banco de dados mas a entrada do usuario
                 -- corresponde a um valor nulo ou zero, o registro da base de dados eh DELETADO
                 -- --------------------------------------------------------------------------------------------------------                                                   	                                                                                                	                     
                 if (not valor or (valor and (valor == '' or valor == ' ')))then                                          
                    if repetido then                                         
                       sql_custo_anual = " DELETE custo_previsto WHERE proj_cod = "..cgi.proj_cod..
                                         " AND dt_prevista = '"..data.."'"                                                                                                                                                                                                            
                       DBExec(sql_custo_anual)                                                  
                       cgi.msgsuc = 1
                    end   
                 end                     
              end
           end           
           j = j - 1        
   
        end          
         i      = i + 1
         limite = 1
      end         
      
      -- --------------------------------------------------------------------------------------------------------
      -- Atualiza o valor de CGI.CUSTO_DIF indicando que os valores de custo anual, custo mensal e os CGIs dos
      -- totais anuais para serem encaminhados para CUSTO_PREVISTO.HTML em cgilua.encodecgi()
      -- --------------------------------------------------------------------------------------------------------      
      cgi.custo_dif = 0
      
      if ESTADO_BD == 'aberto' then
         FechaBD()
      end
         
   end  -- if not( temConteudo(cgi.msg) )
  
   -- --------------------------------------------------------------------------------------
   -- --------------------------------------------------------------------------------------
   -- Ocorrendo ou no erros quando for feita a validacao pelo VALIDFORM os valores de CGI
   -- devem ser reduzidos ao minimo necessario para evitar que o numero de parametros 
   -- passados por CGI extrapolem o maximo permitido
   -- --------------------------------------------------------------------------------------
   -- --------------------------------------------------------------------------------------
   -- Elimina os CGIs desnecessarios na pagina HTML para evitar que o numero de parametros
   -- passados extrapole o valor permitido pelo metodo POST
   -- --------------------------------------------------------------------------------------      	   	        
   cgi.ult_dig_ano_ini = nil
   cgi.mes_ini         = nil
   cgi.ult_dig_ano_fim = nil
   cgi.dia_fim         = nil
   cgi.mes_fim         = nil   
   cgi.alerta          = nil
     
   -- --------------------------------------------------------------------------------------
   -- Elimina os CGIs dos meses anteriores a DATA INICIAL e posteriores a DATA FINAL
   -- --------------------------------------------------------------------------------------   
   ano      = 0
   mes      = 4
   primeira = 0
   
   while ( ano <= 3) do
      valor_ano = cgi['custo_prev_som_ano'..ano]      
      cgi['custo_prev_som_ano'..ano] = nil     
      valor_tot = cgi['custo_prev_tot_ano'..ano]     
      cgi['custo_prev_tot_ano'..ano] = nil   
      while ( mes <= 12 ) do
      	 msg_mes = cgi['msg_custo_prev_'..desc[mes]..ano]
      	 if msg_mes then  
      	    if primeira == 0 then
      	       cgi.msg_erro = cgi['msg_custo_prev_'..desc[mes]..ano]
      	       primeira = 1
      	    end            	 	       	 	
      	    cgi['msg_custo_prev_'..desc[mes]..ano] = nil
      	    cgi[desc[mes]..ano] = 1        	        	          	    
      	 else
      	    cgi['custo_prev_'..desc[mes]..ano] = nil       	     	       	      	
      	 end        	      	 	      	 
      	 mes = mes + 1
      end	
      mes = 1
      ano = ano + 1
   end 	 
      
   -- --------------------------------------------------------------------------------------                          
   -- Indica a proxima pagina que os valores de custo devem ser recuperados do banco
   -- Isso deve ser feito pois para nao estourar o CGI os valores de custo recebem nil
   -- --------------------------------------------------------------------------------------                             
      cgi.tipo_servico = 'edita'  
   
   -- --------------------------------------------------------------------------------------
   -- O redirecionamento soh eh efetuado depois que o numero de CGIs passados eh reduzido
   -- --------------------------------------------------------------------------------------                                          
   if temConteudo(cgi.msg) then
      cgilua.redirect("../custo_previsto.html?"..cgilua.encodecgi())   
   else                
      if cgi.botao == 'voltar' then
         cgilua.redirect("../cadastra.html?proj_cod="..cgi.proj_cod.."&tipo_servico=edita&tipo_edi=projeto")         
      else       
         cgilua.redirect("../custo_previsto.html?"..cgilua.encodecgi())   
      end      
   end          