-- ---------------------------------------------------------------------------------------
-- Comentrio: Luciana - 29/06/2001
-- ---------------------------------------------------------------------------------------
-- A funo PERTENCE() ( GLOBAL.LUA ) faz uso das funes de permisso de acesso, ou seja, 
-- utiliza o arquivo permissao_acesso.lua
-- Mas, quando a insero de permissao_acesso.lua  feita diretamente em GLOBAL.LUA, 
-- ocorrem problemas na execuo da funo nas pginas do diretrio raiz (PEGASO), 
-- extenso HTM
-- Deve ocorrer alguma perda de referncia quanto aos diretrios.
-- Portanto,  necessrio fazer a incluso da permissao_acesso.lua quando for necessrio
-- utilizar a funo PERTENCE()
-- ---------------------------------------------------------------------------------------
assert(dofile('acessabd.lua'))
assert(dofile('permissao_acesso.lua'))
assert(dofile("global.lua"))

if cgi.cac then
   cgi.cac           = gsub(cgi.cac,"'",'"')
else    
   cgi.cac           = ''
end
if cgi.cad then
   cgi.cad           = gsub(cgi.cad,"'",'"')
else
   cgi.cad           = ''   
end
if cgi.cbi then
   cgi.cbi           = gsub(cgi.cbi,"'",'"')
else
   cgi.cbi           = '' 
end
if cgi.ui then
   cgi.ui            = gsub(cgi.ui,"'",'"')
else
   cgi.ui            = ''   
end
if cgi.programa then
   cgi.programa      = gsub(cgi.programa,"'",'"')
else
   cgi.programa      = ''   
end
if cgi.projeto then
   cgi.projeto       = gsub(cgi.projeto,"'",'"')
else
   cgi.projeto       = ''   
end
if cgi.ot_espeficica then
   cgi.ot_especifica = gsub(cgi.ot_especifica,"'",'"')
end

if not cgi.custo_previsto_2000 or cgi.custo_previsto_2000 == '' then
   cgi.custo_previsto_2000 = 0
end
if not cgi.custo_previsto_2001 or cgi.custo_previsto_2001 == '' then
   cgi.custo_previsto_2001 = 0
end
if not cgi.custo_previsto_2002 or cgi.custo_previsto_2002 == '' then
   cgi.custo_previsto_2002 = 0
end
if not cgi.custo_previsto_2003 or cgi.custo_previsto_2003 == '' then
   cgi.custo_previsto_2003 = 0
end

cgi.projeto = gsub(cgi.projeto,"'",'"')
pertence = Pertence()

dt_ini = tonumber(inclui_data(cgi.dt_ini_prevista))
if type(dt_ini) ~= 'number' then
   erro_dt_ini = 'yes'
else
   erro_dt_ini = 'no'   
end 	

--CampoRadio:new { 'Plano Emergencial', "plano_emerg","sim",cgi.plano_emerg}, 
if pertence == "SIM" then
	
   if cgi.dt_ini_prevista and cgi.dt_ini_prevista ~= '' and erro_dt_ini == 'no' then
      form_cadastra = Formulario:new 
      {{
            CampoListaComOutro:new { 'rgo', "orgao","sim", cgi.orgao },
            CampoListaComOutro:new { 'Classificao', "classificacao","nil", cgi.classificacao },
            CampoListaComOutro:new { 'Metas', "metas", "nil" , cgi.metas },
            CampoCaracter:new { 'Projeto', "projeto","sim", nil, nil, cgi.projeto},  
            CampoRadio:new { 'Classificao do Acompanhamento do Projeto', "class_acomp","sim",cgi.class_acomp}, 
            CampoAlfanumerico:new { 'OT Especifica', "ot_especifica",nil, nil, nil, cgi.ot_especifica},  
            CampoCaracter:new { 'Coordenador', "coordenador","sim", nil, nil, cgi.coordenador},  
            CampoListaComOutro:new { 'Prioridade', "prioridade","nil", cgi.prioridade },
            CampoRadio:new { 'Plano Emergencial de Integridade de Dutos', "plano_emerg_duto","sim",cgi.plano_emerg_duto}, 
            CampoData:new 
             {
                'Data prevista para o Inicio', 'dt_ini_prevista', 'sim',
                { 
                   limite = 
                   { 
                      ['>='] = 
                      { 
                         nome = 'um de Abril de 2000', valor = "20000401" 
                      },
      
                      ['<='] = 
                      { 
                         nome = 'trinta e um de Dezembro de 2003', valor = "20031231" 
                      } 
                   } 
                }, nil, 
      	       cgi.dt_ini_prevista, "texto" 
      	    }, 
      
      	    CampoData:new 
             {
                'Data prevista para o fim', 'dt_fim_prevista', 'sim',
                { 
                   limite = 
                   { 
                      ['>'] = 
                      { 
                         nome = 'data e incio prevista para o projeto ('..cgi.dt_ini_prevista..')' , valor = inclui_data(cgi.dt_ini_prevista)
                      },
      
                      ['<='] = 
                      { 
                         nome = 'trinta e um de Dezembro de 2003', valor = "20031231" 
                      } 
                   } 
                }, nil, 
      	       cgi.dt_fim_prevista, "texto" 
      	    }, 
      
             CampoReal:new {'Custo previsto para 2000', 'custo_previsto_2000', nil, 
                { 
                   limite = 
                   { 
                      ['>='] = 
                      { 
                         nome = '0', valor = 0
                      },
                   } 
                }, nil, cgi.custo_previsto_2000 },
             CampoReal:new {'Custo previsto para 2001', 'custo_previsto_2001', nil, 
                { 
                   limite = 
                   { 
                      ['>='] = 
                      { 
                         nome = '0', valor = 0
                      },
                   } 
                }, nil, cgi.custo_previsto_2001 },
             CampoReal:new {'Custo previsto para 2002', 'custo_previsto_2002', nil, 
                { 
                   limite = 
                   { 
                      ['>='] = 
                      { 
                         nome = '0', valor = 0
                      },
                   } 
                }, nil, cgi.custo_previsto_2002 },
             CampoReal:new {'Custo previsto para 2003', 'custo_previsto_2003', nil, 
                { 
                   limite = 
                   { 
                      ['>='] = 
                      { 
                         nome = '0', valor = 0
                      },
                   } 
                }, nil, cgi.custo_previsto_2003 },
            
              CampoCaracter:new 
              { 
                 'Descrio', "descricao","sim",  
                 {       
                    tamanho =     
                    {     
                       ['<='] = 300 
                    }
                 },nil,cgi.descricao   
              },      
             
             -------------------------------------------------------------------------
             --CAMPOS DA TRANSPETRO---------------------------------------------------
             -------------------------------------------------------------------------
             CampoRadio:new { 'Tipo', "tipo", "sim", cgi.tipo },        
             CampoAlfanumerico:new { 'CAC', "cac",nil, nil, nil, cgi.cac },
             CampoAlfanumerico:new { 'CAD', "cad",nil, nil, nil, cgi.cad },       
             CampoAlfanumerico:new { 'CBI', "cbi",nil, nil, nil, cgi.cbi },
             CampoAlfanumerico:new { 'UI', "ui",nil, nil, nil, cgi.ui },
             CampoAlfanumerico:new { 'Programa', "programa",nil, nil, nil, cgi.programa },       
             CampoAlfanumerico:new { 'Projeto', "projeto",nil, nil, nil, cgi.projeto },              
             -------------------------------------------------------------------------
      }}
   else
      form_cadastra = Formulario:new 
      {{
            CampoListaComOutro:new { 'rgo', "orgao","sim", cgi.orgao },
            CampoListaComOutro:new { 'Classificao', "classificacao","nil", cgi.classificacao },
            CampoListaComOutro:new { 'Metas', "metas", "nil", cgi.metas },
            CampoCaracter:new { 'Projeto', "projeto","sim", nil, nil, cgi.projeto},  
            CampoRadio:new { 'Classificao do Acompanhamento do Projeto', "class_acomp","sim",cgi.class_acomp}, 
            CampoAlfanumerico:new { 'OT Especifica', "ot_especifica",nil, nil, nil, cgi.ot_especifica},  
            CampoCaracter:new { 'Coordenador', "coordenador","sim", nil, nil, cgi.coordenador},  
            CampoListaComOutro:new { 'Prioridade', "prioridade","nil", cgi.prioridade },
            CampoRadio:new { 'Plano Emergencial de Integridade de Dutos', "plano_emerg_duto","sim",cgi.plano_emerg_duto}, 
            CampoData:new 
             {
                'Data prevista para o Inicio', 'dt_ini_prevista', 'sim',
                { 
                   limite = 
                   { 
                      ['>='] = 
                      { 
                         nome = 'um de Abril de 2000', valor = "20000401" 
                      },
      
                      ['<='] = 
                      { 
                         nome = 'trinta e um de Dezembro de 2003', valor = "20031231" 
                      } 
                   } 
                }, nil, 
      	       cgi.dt_ini_prevista, "texto" 
      	    }, 

            CampoData:new 
             {
             'Data prevista para o fim', 'dt_fim_prevista', 'sim',
             { 
                limite = 
                { 
                   ['<='] = 
                   { 
                      nome = 'trinta e um de Dezembro de 2003', valor = "20031231" 
                   } 
                } 
             }, nil, 
   	       cgi.dt_fim_prevista, "texto" 
   	    },
      
             CampoReal:new {'Custo previsto para 2000', 'custo_previsto_2000', nil, 
                { 
                   limite = 
                   { 
                      ['>='] = 
                      { 
                         nome = '0', valor = 0
                      },
                   } 
                }, nil, cgi.custo_previsto_2000 },
             CampoReal:new {'Custo previsto para 2001', 'custo_previsto_2001', nil, 
                { 
                   limite = 
                   { 
                      ['>='] = 
                      { 
                         nome = '0', valor = 0
                      },
                   } 
                }, nil, cgi.custo_previsto_2001 },
             CampoReal:new {'Custo previsto para 2002', 'custo_previsto_2002', nil, 
                { 
                   limite = 
                   { 
                      ['>='] = 
                      { 
                         nome = '0', valor = 0
                      },
                   } 
                }, nil, cgi.custo_previsto_2002 },
             CampoReal:new {'Custo previsto para 2003', 'custo_previsto_2003', nil, 
                { 
                   limite = 
                   { 
                      ['>='] = 
                      { 
                         nome = '0', valor = 0
                      },
                   } 
                }, nil, cgi.custo_previsto_2003 },
            
              CampoCaracter:new 
              { 
                 'Descrio', "descricao","sim",  
                 {       
                    tamanho =     
                    {     
                       ['<='] = 300 
                    }
                 },nil,cgi.descricao   
              },      
             
             -------------------------------------------------------------------------
             --CAMPOS DA TRANSPETRO---------------------------------------------------
             -------------------------------------------------------------------------
             CampoRadio:new { 'Tipo', "tipo", "sim", cgi.tipo },        
             CampoAlfanumerico:new { 'CAC', "cac",nil, nil, nil, cgi.cac },
             CampoAlfanumerico:new { 'CAD', "cad",nil, nil, nil, cgi.cad },       
             CampoAlfanumerico:new { 'CBI', "cbi",nil, nil, nil, cgi.cbi },
             CampoAlfanumerico:new { 'UI', "ui",nil, nil, nil, cgi.ui },
             CampoAlfanumerico:new { 'Programa', "programa",nil, nil, nil, cgi.programa },       
             CampoAlfanumerico:new { 'Projeto', "projeto",nil, nil, nil, cgi.projeto },              
             -------------------------------------------------------------------------
      }}	   
   end
   
else
   if cgi.dt_ini_prevista and cgi.dt_ini_prevista ~= '' and erro_dt_ini == 'no' then
      form_cadastra = Formulario:new 
      {{
            CampoListaComOutro:new { 'rgo', "orgao","sim", cgi.orgao },
            CampoListaComOutro:new { 'Classificao', "classificacao","nil", cgi.classificacao },
            CampoListaComOutro:new { 'Metas', "metas","nil", cgi.metas },
            CampoCaracter:new { 'Projeto', "projeto","sim", nil, nil, cgi.projeto},  
            CampoRadio:new { 'Classificao do Acompanhamento do Projeto', "class_acomp","sim",cgi.class_acomp}, 
            CampoAlfanumerico:new { 'OT Especifica', "ot_especifica",nil, nil, nil, cgi.ot_especifica},  
            CampoCaracter:new { 'Coordenador', "coordenador","sim", nil, nil, cgi.coordenador},  
            CampoListaComOutro:new { 'Prioridade', "prioridade","nil", cgi.prioridade },
            CampoRadio:new { 'Plano Emergencial de Integridade de Dutos', "plano_emerg_duto","sim",cgi.plano_emerg_duto},       
            CampoData:new 
             {
                'Data prevista para o Inicio', 'dt_ini_prevista', 'sim',
                { 
                   limite = 
                   { 
                      ['>='] = 
                      { 
                         nome = 'um de Abril de 2000', valor = "20000401" 
                      },
      
                      ['<='] = 
                      { 
                         nome = 'trinta e um de Dezembro de 2003', valor = "20031231" 
                      } 
                   } 
                }, nil, 
      	       cgi.dt_ini_prevista, "texto" 
      	    }, 
      
      	    CampoData:new 
             {
                'Data prevista para o fim', 'dt_fim_prevista', 'sim',
                { 
                   limite = 
                   { 
                      ['>'] = 
                      { 
                         nome = 'data e incio prevista para o projeto ('..cgi.dt_ini_prevista..')' , valor = inclui_data(cgi.dt_ini_prevista)
                      },
      
                      ['<='] = 
                      { 
                         nome = 'trinta e um de Dezembro de 2003', valor = "20031231" 
                      } 
                   } 
                }, nil, 
      	       cgi.dt_fim_prevista, "texto" 
      	    }, 
      
             CampoReal:new {'Custo previsto para 2000', 'custo_previsto_2000', nil, 
                { 
                   limite = 
                   { 
                      ['>='] = 
                      { 
                         nome = '0', valor = 0
                      },
                   } 
                }, nil, cgi.custo_previsto_2000 },
             CampoReal:new {'Custo previsto para 2001', 'custo_previsto_2001', nil, 
                { 
                   limite = 
                   { 
                      ['>='] = 
                      { 
                         nome = '0', valor = 0
                      },
                   } 
                }, nil, cgi.custo_previsto_2001 },
             CampoReal:new {'Custo previsto para 2002', 'custo_previsto_2002', nil, 
                { 
                   limite = 
                   { 
                      ['>='] = 
                      { 
                         nome = '0', valor = 0
                      },
                   } 
                }, nil, cgi.custo_previsto_2002 },
             CampoReal:new {'Custo previsto para 2003', 'custo_previsto_2003', nil, 
                { 
                   limite = 
                   { 
                      ['>='] = 
                      { 
                         nome = '0', valor = 0
                      },
                   } 
                }, nil, cgi.custo_previsto_2003 },
             
              CampoCaracter:new 
              { 
                 'Descrio', "descricao","sim",  
                 {       
                    tamanho =     
                    {     
                       ['<='] = 300 
                    }
                 },nil,cgi.descricao   
              }       
      }}
   else
      form_cadastra = Formulario:new 
      {{
            CampoListaComOutro:new { 'rgo', "orgao","sim", cgi.orgao },
            CampoListaComOutro:new { 'Classificao', "classificacao","nil", cgi.classificacao },
            CampoListaComOutro:new { 'Metas', "metas","nil", cgi.metas },
            CampoCaracter:new { 'Projeto', "projeto","sim", nil, nil, cgi.projeto},  
            CampoRadio:new { 'Classificao do Acompanhamento do Projeto', "class_acomp","sim",cgi.class_acomp}, 
            CampoAlfanumerico:new { 'OT Especifica', "ot_especifica",nil, nil, nil, cgi.ot_especifica},  
            CampoCaracter:new { 'Coordenador', "coordenador","sim", nil, nil, cgi.coordenador},  
            CampoListaComOutro:new { 'Prioridade', "prioridade","nil", cgi.prioridade },
            CampoRadio:new { 'Plano Emergencial de Integridade de Dutos', "plano_emerg_duto","sim",cgi.plano_emerg_duto},       
            CampoData:new 
             {
                'Data prevista para o Inicio', 'dt_ini_prevista', 'sim',
                { 
                   limite = 
                   { 
                      ['>='] = 
                      { 
                         nome = 'um de Abril de 2000', valor = "20000401" 
                      },
      
                      ['<='] = 
                      { 
                         nome = 'trinta e um de Dezembro de 2003', valor = "20031231" 
                      } 
                   } 
                }, nil, 
      	       cgi.dt_ini_prevista, "texto" 
      	    }, 
      
      	    CampoData:new 
             {
                'Data prevista para o fim', 'dt_fim_prevista', 'sim',
                { 
                   limite = 
                   {                             
                      ['<='] = 
                      { 
                         nome = 'trinta e um de Dezembro de 2003', valor = "20031231" 
                      } 
                   } 
                }, nil, 
      	       cgi.dt_fim_prevista, "texto" 
      	    }, 
      
             CampoReal:new {'Custo previsto para 2000', 'custo_previsto_2000', nil, 
                { 
                   limite = 
                   { 
                      ['>='] = 
                      { 
                         nome = '0', valor = 0
                      },
                   } 
                }, nil, cgi.custo_previsto_2000 },
             CampoReal:new {'Custo previsto para 2001', 'custo_previsto_2001', nil, 
                { 
                   limite = 
                   { 
                      ['>='] = 
                      { 
                         nome = '0', valor = 0
                      },
                   } 
                }, nil, cgi.custo_previsto_2001 },
             CampoReal:new {'Custo previsto para 2002', 'custo_previsto_2002', nil, 
                { 
                   limite = 
                   { 
                      ['>='] = 
                      { 
                         nome = '0', valor = 0
                      },
                   } 
                }, nil, cgi.custo_previsto_2002 },
             CampoReal:new {'Custo previsto para 2003', 'custo_previsto_2003', nil, 
                { 
                   limite = 
                   { 
                      ['>='] = 
                      { 
                         nome = '0', valor = 0
                      },
                   } 
                }, nil, cgi.custo_previsto_2003 },
             
              CampoCaracter:new 
              { 
                 'Descrio', "descricao","sim",  
                 {       
                    tamanho =     
                    {     
                       ['<='] = 300 
                    }
                 },nil,cgi.descricao   
              }       
      }}
   end   	            	
      
end