caminho = cgilua.script_vdir
if strfind(caminho,'/lua') then
   cam=''
else
   cam='lua/'
end
assert(dofile(cam..'ACESSABD.LUA'))

--retorna as datas de consolidacao que ainda estao em aberto. Ou seja, jah foram 
--cadastradas mas ainda nao foram efetivadas
function getDatasConsolidacaoAbertas(unidade,prefixo,infixo,sufixo)  
  strSql = [[select cons_cod, cons_dt_prev from consolidacao 
           where unid_cod = ]]..unidade..[[
           and cons_dt_real is null]]
  DBExec(strSql)
  
  saida = ""
  
  plinha = DBRow()
  while plinha do
  	 saida = saida..prefixo..plinha.cons_cod..infixo..plinha.cons_dt_prev..sufixo.."\n"
  	 plinha = DBRow()
  end
  
  return(saida)
end

--verifica se uma determinada UN esta habilitada para efetuar uma nova consolidacao
function habilitadaNovaConsolidacao(unidade, consAtiva)
   strSql = [[select max(seqTentativa) as maxseq from consolidacaoUnidade
              where cons_cod = ]]..consAtiva..[[
              and unid_cod = ]]..unidade
   DBExec(strSql)  
   
   local plinha = DBRow()
   
   if not plinha.maxseq then
      return 1
   end
   
   strSql = [[select aprovada, flagVisualizacao from consolidacaoUnidade
            where cons_cod = ]]..consAtiva..[[
            AND UNID_COD = ]]..unidade..[[
            and seqTentativa = ]]..plinha.maxseq
   DBExec(strSql)
   plinha = DBRow()
     
   if plinha.flagvisualizacao == 1 or plinha.aprovada == 0 then
      return 1
   else
      return nil    
   end
end

--retorna as unidades em que um determinado usuario eh responsavel e que a consolidacao ainda nao aconteceu ou foi desaprovada
function getUnidadesRespondidas(usuario, consAtiva,prefixo,infixo,sufixo)
   
   strSql = [[SELECT unidade.unid_cod, unidade.unid_sigla 
              FROM pessoal, unidade
              WHERE pessoal.pes_cod = unidade.pes_cod_resp 
               and unidade.consolidacao_Habilitada = 1
               AND pessoal.pes_chave = ']]..usuario..[[']]
              
   DBExec(strSql)
   
   saida = ""
   
   plinha = DBRow()
   
   rs = {}
   qrs = 0
   while plinha do
     rs[qrs] = plinha
     plinha = DBRow()
     qrs = qrs + 1
   end

   saida = ""   
   cont = 0
   while cont < qrs do
      plinha = rs[cont]
      if habilitadaNovaConsolidacao(plinha.unid_cod, consAtiva) then
         saida = saida..prefixo..plinha.unid_cod..infixo..plinha.unid_sigla..sufixo.."\n"  
      end    
      cont = cont + 1
   end
   
   return(saida)
end

--retorna as unidades pertencentes a uma AN em que um determinado usuario eh responsvel e que a consolidacao jah aconteceu
function getUnidadesAN(usuario, consAtiva, prefixo, infixo, sufixo)
   strSql = [[select distinct unidade.unid_cod, unidade.unid_sigla 
              from pessoal, unidade, orgao, consolidacaoUnidade
              where pessoal.pes_cod = orgao.pes_cod_resp
                and pessoal.pes_chave = ']]..usuario..[['
                and unidade.org_cod = orgao.org_cod
                and unidade.unid_cod = consolidacaoUnidade.unid_cod
                and consolidacaoUnidade.cons_cod = ]]..consAtiva..[[
                and consolidacaoUnidade.flagVisualizacao = 0
                and consolidacaoUnidade.aprovada is null]]
   
   DBExec(strSql)   
   plinha = DBRow()
   
   rs = {}
   qrs = 0
   while plinha do
      rs[qrs] = plinha
      plinha = DBRow()
      qrs = qrs + 1
   end

   saida = ""   
   cont = 0
   while cont < qrs do
      plinha = rs[cont]
      saida = saida..prefixo..plinha.unid_cod..infixo..plinha.unid_sigla..sufixo.."\n"          
      cont = cont + 1
   end
   
   return(saida)
end

--retorna quantas unidades pentencentes a uma AN em que um determinado usuario eh responsvel em qua a consolidacao jah conteceu
function getQuantasUnidadesAN(usuario, consAtiva)
   strSql = [[select count(unidade.unid_cod) as quantas
              from pessoal, unidade, orgao, consolidacaoUnidade
              where pessoal.pes_cod = orgao.pes_cod_resp
              and pessoal.pes_chave = ']]..usuario..[['
              and unidade.org_cod = orgao.org_cod
              and unidade.unid_cod = consolidacaoUnidade.unid_cod
              and consolidacaoUnidade.cons_cod = ]]..consAtiva..[[
              and consolidacaoUnidade.flagVisualizacao = 0
              and consolidacaoUnidade.aprovada is null]]
   
   DBExec(strSql)
   plinha = DBRow();
   
   return plinha.quantas  
end

--retorna o sequencial da tentativa de uma determinada unidade em uma determinada consolidacao
function getSeqTentativa(unidade, consolidacao)
   strSql = [[select max(seqTentativa) as seq
              from consolidacaoUnidade
              where cons_cod = ]]..consolidacao..[[
                and unid_cod = ]]..unidade..[[
                and flagVisualizacao = 0]]
   
   DBExec(strSql)   
   plinha = DBRow();
   
   if plinha.seq then
     return plinha.seq
   else
     return 0
   end
end    

--retorna em checkbox das unidades, marcando se estao habilitadas para a consolidacao
function getUnidadesHabilitadasCheckbox(prefixo,sufixo)
   strSql = [[select unid_cod, unid_sigla, consolidacao_habilitada from unidade]]
   DBExec(strSql)
   saida = ""
   
   plinha = DBRow()
   while plinha do
     	saida = saida..prefixo..'<input type="checkbox" name="c'..plinha.unid_cod..'" value="'..plinha.unid_cod..'" '
     	if plinha.consolidacao_habilitada == 1 then
         saida = saida..'checked'
      end
     	saida = saida..'>'..plinha.unid_sigla..sufixo
     	plinha = DBRow()
   end
   
   return(saida)
end

--retorna o codigo da consolidacao que esta ativa
function getConsolidacaoAtiva()
   
   DBExec('select cons_cod from consolidacao where ativa = 1')   
   plinha = DBRow()
   
   if plinha then
      return plinha.cons_cod
   else
      return nil
   end
end

--retorna o codigo da ultima consolidacao
function getUltimaConsolidacao()
   DBExec('select max(cons_cod) as cons_cod from consolidacao')
   plinha = DBRow()
   
   if plinha then
      return plinha.cons_cod
   else
      return nil
   end
end

--verifica se uma determinada UN possui flagVisualizacao ativo.
function estaAtivaVisualizacao(un, cod)   
   local strSql = [[select count(*) as cont from consolidacaoUnidade 
                    where flagVisualizacao = 1 and unid_cod = ]]..un..[[
                    and cons_cod = ]]..cod
   DBExec(strSql)   
   local plinha = DBRow()
   
   if plinha then
     if plinha.cont > 0 then
       return(1)
     end
          
     return nil     
   end
   
   return nil
end

--retorna quantas unidades em que um determinado usuario eh responsavel e que a consolidacao ainda nao aconteceu
function getQuantasUnidadesRespondidas(usuario, consAtiva)
   strSql = [[SELECT unidade.unid_cod, unidade.unid_sigla 
              FROM pessoal, unidade 
              WHERE pessoal.pes_cod = unidade.pes_cod_resp 
              AND unidade.consolidacao_habilitada = 1
              AND pessoal.pes_chave = ']]..usuario..[[']]
              
   DBExec(strSql)   
   plinha = DBRow()
   rs = {}
   while plinha do
      tinsert(rs, plinha)
      plinha = DBRow()
   end
     
   quantas = { num = 0 }
   
   foreachi(rs, function (i, plinha)
     if habilitadaNovaConsolidacao(plinha.unid_cod, %consAtiva) then
        %quantas.num = %quantas.num + 1
     end    
   end)
   
   return quantas.num
end

--retorna as unidades respondidas por um determinado usuario em que j aconteceu pelo menos uma tentativa de consolidacao
function getUnidadesConsolidadas(usuario, consAtiva, prefixo, infixo, sufixo)
   
   strSql = [[SELECT unidade.unid_cod, unidade.unid_sigla 
              FROM pessoal, unidade
              WHERE pessoal.pes_cod = unidade.pes_cod_resp               
               AND pessoal.pes_chave = ']]..usuario..[['
               AND unidade.unid_cod in (select distinct unid_cod 
                                        from consolidacaoUnidade
                                        where cons_cod = ]]..consAtiva..[[)]]
   
   DBExec(strSql)   
   plinha = DBRow()
   
   saida = ""   
   cont = 0
   while plinha do    
      saida = saida..prefixo..plinha.unid_cod..infixo..plinha.unid_sigla..sufixo.."\n"          
      plinha = DBRow()
   end
   
   return(saida)
end

--retorna quantas unidades respondidas por um determinado usuario em que j aconteceu pelo menos uma tentativa de consolidacao
function getQuantasUnidadesConsolidadas(usuario, consAtiva, prefixo, infixo, sufixo)
   
   strSql = [[SELECT count(unidade.unid_cod) as quantas 
              FROM pessoal, unidade
              WHERE pessoal.pes_cod = unidade.pes_cod_resp               
              AND pessoal.pes_chave = ']]..usuario..[['
              AND unidade.unid_cod in (SELECT distinct unid_cod 
                                       FROM consolidacaoUnidade
                                       WHERE cons_cod = ]]..consAtiva..[[
                                       AND flagVisualizacao = 0)]]   
   DBExec(strSql)   
   plinha = DBRow()
   
   return(plinha.quantas)
end

--retorna a data da consolidacao ativa
function getDataConsolidacaoAtiva()
   DBExec('select cons_dt_prev from consolidacao where ativa = 1')  
   plinha = DBRow()
   
   if not plinha then
      return nil
   end
   
   return plinha.cons_dt_prev
end

--retorna a chave da pessoa responsave pela AN a que pertence uma dada UN
function getChaveRespAN(unid_cod)
   strSql = [[select pessoal.pes_chave from unidade, orgao, pessoal
              where unidade.org_cod = orgao.org_cod
               and orgao.pes_cod_resp = pessoal.pes_cod
               and unidade.unid_cod = ]]..unid_cod
   DBExec(strSql)   
   plinha = DBRow()
   
   
   if not plinha then
      return nil
   end
   
   return plinha.pes_chave
end

--retorna a chave da pessoa responsave pela UN
function getChaveRespUN(unid_cod)
   strSql = [[select pessoal.pes_chave from unidade, pessoal
              where unidade.pes_cod_resp = pessoal.pes_cod
               and unidade.unid_cod = ]]..unid_cod
   DBExec(strSql)   
   plinha = DBRow()
   
   if not plinha then
     return nil
   end
   
   return plinha.pes_chave
end

--retorna o codigo da AN responsavel por uma dada UN
function getCodAN(unid_cod)
   DBExec('select org_cod from unidade where unid_cod = '..unid_cod)
   plinha = DBRow()
   
   if not plinha then
      return nil
   end
   
   return plinha.org_cod
end

--retorna a chave de uma pessoa dado o codigo
function getChavePes(pes_cod)
   DBExec('select pes_chave from pessoal where pes_cod = '..pes_cod)
  
   if not plinha then
      return nil
   end
  
   return plinha.pes_chave
end

--retorna a SIGLA e a DESCRICAO da UN
function getSiglaDescrUN(unid_cod)
   local strSql = [[SELECT unid_sigla, unid_nome FROM unidade WHERE unid_cod = ]]..unid_cod
   DBExec(strSql)   
   local plinha = DBRow()
   
   if not plinha then
     return nil
   end
   
   return plinha.unid_sigla, plinha.unid_nome
end