import java.applet.Applet;
import java.applet.AppletStub;
import java.awt.Graphics;
import java.awt.GridLayout;
import java.awt.Label;
import java.util.Vector;

// This applet is responsible for loading another applet in the
// background and displaying the applet when it finishes loading.
// The name of the applet to load is supplied by a <PARAM> tag.
// For example:
// <PARAM name="applet" value="RealApplet">
// which would load an applet class called RealApplet
//

public class PreLoader extends Applet implements Runnable, AppletStub
{
  Vector appletList;
  int paramName;
  int INITIAL_APPLETS_NUM = 20;
  String appletToLoad;
  String label;
  Thread appletThread;

  public void init()
  {
    paramName = 1;
    appletList = new Vector(INITIAL_APPLETS_NUM);

    // Get the name of the applet to load
    appletToLoad = getParameter(String.valueOf(paramName));
    while(appletToLoad != null) {
      if(appletList.contains(appletToLoad) == false) {
        appletList.addElement(appletToLoad);
        System.out.println("Got a class: PARAM= " + paramName + " CLASS= " + appletToLoad);
      }
      paramName++;
      appletToLoad = getParameter(String.valueOf(paramName));
    }

    // If the isn't one, print a message
    if(appletList.isEmpty()) {
      label = "No applet to load.";
    }
    else {
      label = "Please wait - loading applet(s)";
    }
    System.out.println(label);
  } 

  public void run()
  {
    // If there's no applet to load, don't bother loading it!
    if(appletList.isEmpty()) return;

    try {
      Class appletClass[];
      Applet realApplet[];
      //ChronogramUI applet1;
      //Chronogram applet2;
      //AbstractChronogram applet3;
      int nsize = appletList.size();
      int i;

      appletClass = new Class[nsize];
      realApplet = new Applet[nsize];

      //applet1  = new ChronogramUI();
      //applet3  = new Chronogram();

//      class1 = Class.forName( String.valueOf(appletList.elementAt(0)) );
//      class2 = Class.forName( String.valueOf(appletList.elementAt(1)) );
//      class3 = Class.forName( String.valueOf(appletList.elementAt(2)) );

//      System.out.println("instance 1");
//      applet1 = (Applet)class1.newInstance();
//      applet1.setStub(this);
//      System.out.println("instance 2");
//      applet2 = (Applet)class2.newInstance();
//      applet2.setStub(this);
//      System.out.println("instance 3");
//      applet3 = (Applet)class3.newInstance();
//      applet3.setStub(this);

//      System.out.println("init 1");
//      applet1.init();
//      System.out.println("init 2");
//      applet2.init();
//      System.out.println("init 3");
//      applet3.init();

      for(i = 0; i < nsize; i++) {
        // Get the class for the applet we want
        String appletName = String.valueOf( appletList.elementAt(i) );
        System.out.println("Loading class: " + appletName + " ...");
        appletClass[i] = Class.forName(appletName);

        System.out.println("1");
        // Create an instance of the applet
        realApplet[i] = (Applet)appletClass[i].newInstance();

        System.out.println("2");
        // Set the appet's stub - this will allow the real applet to use
        // this applet's document base, code base, and applet context.
        realApplet[i].setStub(this);
      }

      System.out.println("3");
      for(i=0; i < nsize; i++) {
        // Crank up the real applet
        System.out.println("applet " + appletList.elementAt(i) + " init");
        realApplet[i].init();
      }
    }
    catch(IllegalAccessException e) {
      System.out.println("Class could not be accessed.");
    }
    catch(ClassNotFoundException e) {
      System.out.println("Class not found.");
    }
    catch(ArrayIndexOutOfBoundsException e) {
      System.out.println("Array index out of bounds.");
    }
    catch(Exception e) {
      // If we got an error anywhere, print it
      System.out.println("Error loading applet.");
    }

  }

  public void start()
  {
    appletThread = new Thread(this);
    appletThread.start();
  }

  public void stop()
  {
    appletThread.stop();
    appletThread = null;
  }

  // appletResize is the one method in the AppletStub interface that
  // isn't in the Applet class. You can use the applet resize
  // method and hope it works.
  public void appletResize(int width, int height)
  {
    resize(width, height);
  }

} 
