import java.util.Vector;
import java.awt.*;

public class TimeFrame {
  // implementation
  // bounds
  //Point upperleft;
  //Point lowerright;
  //int yearsXPos;
  //int monthsXPos;

  int stripeHeight;
  int leftBorder;
  int rightBorder;
  int leftBorderWidth;
  int rightBorderWidth;

  // YearSet's
  Vector stripes;

  TimeFrame()
  {
    stripes = new Vector();
  }

  void addStripe(YearSet set)
  {
    stripes.addElement(set);
  }

  //void setBounds(int x0, int y0, int x1, int y1)
  //{
  //  upperleft.x = x0;
  //  upperleft.y = y0;
  //  lowerright.x = x1;
  //  lowerright.y = y1;

    // determine yearsXPos;
    // determine monthsXPos;
  //}

  void setStripeHeight(int height) {
    stripeHeight = height;
  }

  // left border
  void setLeftBorderPosition(int position) {
    leftBorder = position;
  }

  void setLeftBorderWidth(int width) {
    leftBorderWidth = width;
  }

  // right border
  void setRightBorderPosition(int position) {
    rightBorder = position;
  }

  void setRightBorderWidth(int width) {
    rightBorderWidth = width;
  }

  void draw(Graphics g, int y0, int height, int stripeHeight,
            int start, int end,
            CoordinateMapper mapper)
  {
    YearSet ys;

    this.drawStripes(g, start, end,
                     y0, stripeHeight, mapper);

    for(int i=0; i<stripes.size(); i++) {
      ys = (YearSet)stripes.elementAt(i);
      ys.draw(g, y0, height, mapper);
    }
  }

//  drawLabels()
//  {
//    for(int i=0; i < stripes.size(); i++) {
//        // draw year[i] at (centered at pos, yearsXPos)
//      for(int j=0; j < stripes.ElementAt(i).size(); j++) {
//        // draw month[i][j] at (monthsXPos, centered at pos, monthsXPos)
//      }
//    }
//  }

    void drawStripes(Graphics g, int uStart, int uEnd,
                     int y0, int height,
                     CoordinateMapper cm)
    {
      int x,y,dx,dy;
      int sStart, sEnd;
      int nsize;
      YearSet ys0, ys1;
      boolean fColor = true;
      Color cTrue = CustomColor.xCCCCCC;
      Color cFalse = CustomColor.x999999;
      Color old = g.getColor();

      y = y0;
      dy = height;
      sStart = cm.user2Screen(uStart);
      sEnd = cm.user2Screen(uEnd);

      // 1st yearset fill stripe
      dx = leftBorderWidth;
      x = sStart - dx;
      if(fColor) g.setColor(cTrue);
      else g.setColor(cFalse);
      g.fillRect(x,y, dx,dy);
      x += dx;

      nsize = stripes.size();
      for(int i=0; i<nsize; i++) {
        if((i+1) < nsize) {
          int xp;
          ys0 = (YearSet)stripes.elementAt(i);
          ys0.calcYearPosition();
          ys1 = (YearSet)stripes.elementAt(i+1);
          ys1.calcYearPosition();
          //xp = (ys1.year.pos + ys0.year.pos) / 2;
          xp = (ys1.min + ys0.max) / 2;
          dx = cm.user2Screen(xp) - x;
        }
        else {
          int xp;
          ys1 = (YearSet)stripes.elementAt(i);
          // last yearset
          xp = ys1.max;
          dx = cm.user2Screen(xp) - x; 
        }

        if(fColor) g.setColor(cTrue);
        else g.setColor(cFalse);

        g.fillRect(x,y, dx,dy);
        fColor = !fColor;
        x += dx;
      }

      fColor = !fColor;
      // x before sEnd
      if(x!=sEnd) {
        dx = sEnd - x;
        if(fColor) g.setColor(cTrue);
        else g.setColor(cFalse);

        g.fillRect(x,y, dx,dy);
      }
      // x at sEnd
      else {
        // right border
        dx = rightBorderWidth;
        if(fColor) g.setColor(cTrue);
        else g.setColor(cFalse);
        g.fillRect(x,y, dx,dy);
      }

      g.setColor(old);
    }

}
