------------------------- funcoes_estilisticas.lua -----------------------------
--
-- PUC-Rio
-- Departamento de Informtica
--
-- Projeto:	VALIDAFORM
-- Arquivo: 	funcoes_estilisticas.lua
-- Descrio:  	Biblioteca com funes estilisticas para a gerao de texto em 
--		portugus. Est em desenvolvimento, contendo apenas as funes 
--		utilizadas pelos mtodos geradores de mensagens de erro do 
--		VALIDAFORM. 
		 
-- Data:	21/04/1999
-- Autor:      	Gilda Dahis
--
-- 
-- Alteraes:
--     Quem    |   Quando   |   Motivo
-- ------------|------------|---------------------------------------------------
--   
--------------------------------------------------------------------------------

-------------------------------------------------------------------------------
function numero_ou_artigo( quantidade, genero )
--------------------------------------------------------------------------------
-- Descrio: 	Dada uma quantidade e um gnero, retorna a quantidade quando es-
--		ta for maior do que 1, ou o nmero 1 por extenso, em caso con-
--		trrio e de acordo com o gnero (um ou uma).

-- Parmetros:	
--		quantidade:	inteiro indicando uma quantidade.
--		gnero:		caracter indicando um gnero ('o'- masculino e
--				'a'- feminino)

-- Retorno: 	Retorna a quantidade quando esta or maior que 1, ou o nmero 1 
--		por extenso, em caso contrrio e de acordo com o gnero 
--		(um ou uma).
		
-- Autora: 	Gilda Dahis
-- Data: 	06/01/1998
--------------------------------------------------------------------------------
	if 	quantidade == 1 then
		return artigo_indefinido[genero]
	elseif 	quantidade > 1 then
		return quantidade
	else
		--ERRO:Se valor_restricao for menor que 1, foi mal especificado!!!
		error( 'Parmetro quantidade < 1!'  )
	end
	
end

-------------------------------------------------------------------------------
function ordinal( genero ) 
--------------------------------------------------------------------------------
-- Descrio: 	Dado um gnero, retorna tags html para compor o smbolo para a 
--		contagem ordinal de elementos daquele gnero, ou seja 'a' ou 'o' 
--		sobescrito.

-- Parmetros:	
--		gnero:		caracter indicando um gnero ('o'- masculino e
--				'a'- feminino).

-- Retorno: 	Retorna tags html para compor o smbolo para a contagem ordinal 
--		de elementos daquele gnero, ou seja 'a' ou 'o' sobescrito.
		
-- Autora: 	Gilda Dahis
-- Data: 	06/01/1998
--------------------------------------------------------------------------------
	return '<SUP><U>'..genero..'</SUP></U>'
end
 
-------------------------------------------------------------------------------
function primeira_maiuscula( str ) 
--------------------------------------------------------------------------------
-- Descrio: 	Dada uma string, retorna a string com a primeira letra 
--		maiscula. (Utilizada para a inicializao de frases).

-- Parmetros:	
--		str: string indicando a palvra ou a locuo que inicia uma fra-
--		se.
-- Retorno: 	Retorna a string com a primeira letra maiscula.		

-- Autora: 	Gilda Dahis
-- Data: 	06/01/1998
--------------------------------------------------------------------------------
--retorna 'str' com a primeira letra maiscula (para inicializar frases).
  return strupper( strsub(str,1,1) )..strsub( str, 2 )
end
