------------------------- regras_transformacao.lua -----------------------------
--
-- PUC-Rio
-- Departamento de Informtica
--
-- Projeto:	VALIDAFORM
-- Arquivo: 	regras_transformacao.lua
-- Descrio:  	Biblioteca com funes que realizam transformaes em sentenas
--		ou subsentenas bsicas, como coordenaes, etc.
		 
-- Data:	21/04/1999
-- Autor:      	Gilda Dahis
--
-- 
-- Alteraes:
--     Quem    |   Quando   |   Motivo
-- ------------|------------|---------------------------------------------------
--   
--------------------------------------------------------------------------------

--Quando estiver debugando, retire os comentrios das 2 linhas a seguir
--cgilua.htmlheader()
--$debug

--------------------------------------------------------------------------------
function coordena( lista, num_itens, conjuncao )
--------------------------------------------------------------------------------
-- Descrio: 	Dada uma lista de strings e uma conjuno, retorna uma coordena-
--		o das strings, onde as duas ltimas so separadas pela 
--		conjuno. 

-- Parmetros:  lista: tabela com as strings a serem coordenadas.
--		num_itens: inteiro indicando o nmero de strings na lista.
--		conjuncao: string indicando a conjuno que separar as duas 
--		ltimas strings da lista.

-- Retorno:	retorna uma coordenao de strings, separadas por virgulas e onde 
--		as duas ltimas so separadas por uma conjuno.
 
-- Autora: 	Gilda Dahis
-- Data:	07/06/1998
-- Alterado por: 
-- Em:
--------------------------------------------------------------------------------
    local item, descricao, coordenacao
    
    --L o primeiro item da lista
    item, descricao = next( lista, nil )
    
    --inicializa a coordenao com ele
    coordenacao = descricao
    
    itens_coordenados = 1
	
    item, descricao = next( lista, item )
		    
    --Coordena at o penltimo item
    while itens_coordenados < num_itens - 1 do
          coordenacao = coordenacao..', '..descricao
          itens_coordenados = itens_coordenados + 1
    	  item, descricao = next( lista, item )
    end
    
    --Se existe mais de um item, separar os dois ltimos com 'e'.
    if  num_itens > 1 then
        coordenacao = coordenacao.." "..conjuncao.." "..descricao
    end
    return coordenacao
end

--function itemiza( lista )
--
--end