----------------------------- validaform.lua ---------------------------------------
--
-- PUC-Rio
-- Departamento de Informtica
--
-- Projeto:	VALIDAFORM
-- Arquivo: 	validdaform.lua
-- Descrio:  	Este  o arquivo principal da biblioteca. Carrega todos os outros 
--		mdulos do VALIDAFORM e contm os parmetros para a configurao 
--		adequada ao sistema que utiliza o VALIDAFORM.
--		 
-- Data:	06/01/1998
-- Autor:      	Gilda Dahis
--
-- 
-- Alteraes: 
--     Quem      |   Quando   |   Motivo
-- --------------|------------|-------------------------------------------------
--  efmendes	 |  21/05/01  |	retirada dos caminhos desse arquivo e criacao
--               |	      |	de um arquivo de caminhos
--------------------------------------------------------------------------------

$debug
-------------------------------------------------------------------------------
-- Variveis Globais para a configurao do VALIDAFORM
-------------------------------------------------------------------------------
dofile("../lua/global.lua")
-- le os caminhos
--dofile("caminhos.lua")

CAMINHOS = 
{ 
  ["/pegaso/lua/"] = "../VALIDAFORM/",
  ["/pegaso/"]     = "/VALIDAFORM", 
  ["/susema/pegaso/lua/"] = "../VALIDAFORM/",
  ["/susema/pegaso/"] = "VALIDAFORM/",
  ["/vss_wf/"..getuser().."/pegaso/lua/"] = "../VALIDAFORM/",
  ["/vss_wf/"..getuser().."/pegaso/"] = "VALIDAFORM/",
  ["/vss_shadow/pegaso/" ] = "VALIDAFORM/",
  ["/vss_shadow/pegaso/lua/"] = "../VALIDAFORM/",
  ["/vss_wf/"..getuser().."/pegaso/lua/"] = "../VALIDAFORM/",
}	


--Caminhos relativos entre o diretrio onde esto instaladas as bibliotecas do 
--VALIDAFORM e os diretrios dos scripts que as chamam  


--Determinar o DSN
if 	strfind(strupper(cgilua.script_pdir), 'TST') then
 		DSN = 'pegaso'
else
		DSN = 'pegaso'
end

--DSN = 'susema' 	--DSN do Banco de Dados do sistema que utiliza o 
--			--VALIDAFORM
			
ESTILO_MSG = 'MSGERRO'	--Estilo especificado no arquivo de 'Cascading Style 
			--Sheeds que deve ser utilizado para formatar as mensa-
			--gens de erro

if 	not CAMINHOS[strlower(cgilua.script_vdir)] then
	error('Voc deve especificar uma entrada para o diretrio virtual "'..
	tostring(cgilua.script_vdir)..[[" na tabela de configurao CAMINHOS do
	arquivo "validaform.lua", da biblioteca VALIDAFORM. Para faz-lo,
	consulte o manual do usurio da Biblioteca.]])
end

--error(cgilua.script_vdir, CAMINHOS[cgilua.script_vdir])
--Troca o diretrio corrente para o caminho dos mdulos do VALIDAFORM
chdir( cgilua.script_pdir..CAMINHOS[strlower(cgilua.script_vdir)] )

--------------------------------------------------------------------------------
--Carrega classes e funes utilizadas neste mdulo
--------------------------------------------------------------------------------
--Classes de Campos de Formulrio
dofile( 'campo.lua' )
dofile( 'campoLimitadoInterface.lua' )
dofile( 'campoIlimitado.lua' )
dofile( 'campoSimples.lua' )
dofile( 'campoEstruturado.lua' )

--Carrega a classe Formulario
dofile( 'formulario.lua' )

--Carrega Mtodos para a gerao das mensagens de erro
--(Gerador de mensagens de erro utilizado atualmente pela biblioteca)
dofile( "gerador_msg_erro.lua" )

--Retorna para o diretrio corrente 
chdir( cgilua.script_pdir )

